
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "treedcsw.h"

// como el nodo en memoria, pero con enteros en lugar de punteros 
struct tnodof{
   int tiponodo;
   int variable;
   int umbral;
   int menor, mayorIgual;} ;

// -------------------- --------------------

tpnodo nodoalloc ()
{
   return ( (tpnodo) malloc(sizeof(struct tnodo)) );
}

tpnodo creaNodo (int clNodo, int variable, int umbral, tpnodo menor, tpnodo mayorIgual)
{
   tpnodo nnodo ;
   nnodo = nodoalloc ();
   nnodo->tiponodo   = clNodo;
   nnodo->variable   = variable;
   nnodo->umbral     = umbral;
   nnodo->menor      = menor;
   nnodo->mayorIgual = mayorIgual;
   return nnodo ;
}

void anadeNodoHMenor (tpnodo np, tpnodo nh)
{
   np->menor = nh;
}

void anadeNodoHMayorI (tpnodo np, tpnodo nh)
{
   np->mayorIgual = nh;
}

void destruyeArbol (tpnodo nodo)
{
   if (nodo->tiponodo == nd_segun) {
      destruyeArbol (nodo->menor);
      destruyeArbol (nodo->mayorIgual);
      }
   free (nodo);
}

// -------------------- --------------------

int tamRama (tpnodo rama)
{
   if (rama->tiponodo == nd_segun)
      return tamRama(rama->menor) + tamRama(rama->mayorIgual) + 1 ;
   else
      return 1 ;
}

int tamArbol (tpnodo rama)
{
   return tamRama (rama);
}

// -------------------- --------------------

int escribeRama (int fd, tpnodo rama, int * dnodosEscritos)
{
   // int pmn, pmy;
   struct tnodof nodof;
   nodof.tiponodo = rama->tiponodo ;
   nodof.variable = rama->variable ;
   nodof.umbral   = rama->umbral ;
   if (rama->tiponodo == nd_segun) {
      nodof.menor      = escribeRama (fd, rama->menor, dnodosEscritos);
      nodof.mayorIgual = escribeRama (fd, rama->mayorIgual, dnodosEscritos);
      }
   else {
      nodof.menor      = 0 ;
      nodof.mayorIgual = 0 ;
      }
   write (fd, & nodof, sizeof(nodof));
   (* dnodosEscritos) ++ ;
   return  (* dnodosEscritos) - 1 ; 
}

void escribeArbol (char * nomFich, tpnodo arbol)
{
   int nodosEscritos;
   int fd;
   fd = open (nomFich, O_WRONLY | O_CREAT | O_TRUNC, 0666);
   if (fd < 0) {
      printf ("error en treedcsw.escribeArbol al intentar abrir %s\n", nomFich);
      exit (1);
      }
   nodosEscritos = 0;
   escribeRama (fd, arbol, &nodosEscritos);
   close (fd);
}

// -------------------- --------------------

int escribeSeRamaTexto (tpnodo rama, int * dnodosEscritos)
{
   int pmn, pmy;
   if (rama->tiponodo == nd_segun) {
      pmn    = escribeSeRamaTexto (rama->menor, dnodosEscritos);
      pmy    = escribeSeRamaTexto (rama->mayorIgual, dnodosEscritos);
      printf ("%4d segun  %5d %5d %5d %5d\n",
                   * dnodosEscritos,
                   rama->variable, rama->umbral, pmn, pmy);
      }
   else {
      switch (rama->tiponodo) {
         case nd_falso :
            printf ("%4d falso     --    --    --    --\n", *dnodosEscritos);
            break ;;
         case nd_cierto:
            printf ("%4d cierto    --    --    --    --\n", *dnodosEscritos);
            break ;;
         case nd_nose  :
            printf ("%4d nose      --    --    --    --\n", *dnodosEscritos);
            break ;;
         }
      }
   (* dnodosEscritos) ++ ;
   return (* dnodosEscritos) - 1 ; 
}

void escribeSeArbolTexto (tpnodo arbol)
{
   int nodosEscritos;
   nodosEscritos = 0;
   escribeSeRamaTexto (arbol, &nodosEscritos);
}

// -------------------- --------------------

tpnodo leeRama (int fd, int posicion)
{
   struct tnodof nodof;
   tpnodo nnodo ;
// situarse en posicion
   lseek (fd, posicion * sizeof(nodof), SEEK_SET); 
   read (fd, & nodof, sizeof(nodof));
   nnodo = nodoalloc ();
   nnodo->tiponodo   = nodof.tiponodo ;
   nnodo->variable   = nodof.variable ;
   nnodo->umbral     = nodof.umbral ;
   if (nodof.tiponodo == nd_segun) {
      nnodo->menor      = leeRama(fd, nodof.menor);
      nnodo->mayorIgual = leeRama(fd, nodof.mayorIgual);
      }
   else {
      nnodo->menor      = NULL ;
      nnodo->mayorIgual = NULL ;
      }
   return nnodo;
}

tpnodo leeArbol (char * nomFich)
{
   int fd;
   int posicion, tam;
   struct tnodof nodof;
   tpnodo arbol;
   fd = open (nomFich, 0);
   if (fd < 0) {
      printf ("error en treedcsw.leeArbol al intentar abrir %s\n", nomFich);
      exit (1);
      }
   tam = lseek (fd, 0L, SEEK_END);
   posicion = (tam / sizeof(nodof)) - 1 ;
   arbol = leeRama (fd, posicion);
   close (fd);
   return arbol;
}

// -------------------- --------------------

/*
// innecesario, igual que escribeRama
int escribeRama2 (int fd, tpnodo rama, int * dnodosEscritos)
{
   // int pmn, pmy;
   struct tnodof nodof;
   nodof.tiponodo = rama->tiponodo ;
   nodof.variable = rama->variable ;
   nodof.umbral   = rama->umbral ;
   if (rama->tiponodo == nd_segun) {
      nodof.menor      = escribeRama (fd, rama->menor, dnodosEscritos);
      nodof.mayorIgual = escribeRama (fd, rama->mayorIgual, dnodosEscritos);
      }
   else {
      nodof.menor      = 0 ;
      nodof.mayorIgual = 0 ;
      }
   write (fd, & nodof, sizeof(nodof));
   (* dnodosEscritos) ++ ;
   return  (* dnodosEscritos) - 1 ; 
}
*/

void escribeArbol2 (char * nomFich, tpnodo arbol[], int n)
{
   int nodosEscritos;
   int fd;
   int i;
   int tam;
   fd = open (nomFich, O_WRONLY | O_CREAT | O_TRUNC, 0666);
   if (fd < 0) {
      printf ("error en treedcsw.escribeArbol2 al intentar abrir %s\n", nomFich);
      exit (1);
      }
   write (fd, &n, sizeof(int));
   for (i=0; i<n; i++){
      tam = tamArbol (arbol[i]);
      write (fd, & tam, sizeof(int));
      }
   for (i=0; i<n; i++) {
      nodosEscritos = 0;
      escribeRama (fd, arbol[i], &nodosEscritos);
      }
   close (fd);
}

// -------------------- --------------------

tpnodo leeRama2 (int fd, int posicion, int desp)
{
   struct tnodof nodof;
   tpnodo nnodo ;
// situarse en posicion
   lseek (fd, posicion * sizeof(nodof) + desp, SEEK_SET); 
   read (fd, & nodof, sizeof(nodof));
   nnodo = nodoalloc ();
   nnodo->tiponodo   = nodof.tiponodo ;
   nnodo->variable   = nodof.variable ;
   nnodo->umbral     = nodof.umbral ;
   if (nodof.tiponodo == nd_segun) {
      nnodo->menor      = leeRama2(fd, nodof.menor, desp);
      nnodo->mayorIgual = leeRama2(fd, nodof.mayorIgual, desp);
      }
   else {
      nnodo->menor      = NULL ;
      nnodo->mayorIgual = NULL ;
      }
   return nnodo;
}

void leeArbol2 (char * nomFich, tpnodo *arbol, int *na)
{
   int fd;
   // int posicion, tam;
   struct tnodof nodof;
   int n;                  // numero de arboles
   int *tams;              // tamanios de los arboles, medido en nodos
   int atams;              // acumulado de tams
   int i;
   // tpnodo arbol;
   fd = open (nomFich, 0);
   if (fd < 0) {
      printf ("error en treedcsw.leeArbol2 al intentar abrir %s\n", nomFich);
      exit (1);
      }
   read (fd, &n, sizeof(int));
   tams = malloc (n * sizeof(int));
   read (fd, tams, n * sizeof(int));
   atams = 0;
   for (i=0; i<n; i++) {
      // tam = lseek (fd, 0L, SEEK_END);
      // posicion = (tam / sizeof(nodof)) - 1 ;
      arbol[i] = leeRama2 (fd, tams[i] - 1, (n+1)*sizeof(int) + atams*sizeof(nodof));
      atams += tams[i];
   }
   close (fd);
   *na = n;
   // return arbol;
}

// -------------------- --------------------

int evalArbolVector (tpnodo arb, int v[])
{
   switch (arb->tiponodo) {
      case nd_falso   :
         return nd_falso ;
      case nd_cierto  :
         return nd_cierto ;
      case nd_nose    :
         return nd_nose ;
      case nd_segun   :
         if (v[arb->variable] < arb->umbral) 
            return evalArbolVector (arb->menor, v);
         else    // mayor o igual
            return evalArbolVector (arb->mayorIgual, v);
      }
   return nd_nose ;  // no llega aqui. para evitar warning
}

