
#include <aspell.h>
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "artefactos.h"
#include "base.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "imag.h"
#include "imagx.h"
#include "letrasuIdiom.h"
#include "lista.h"
#include "mayusMinus.h"
#include "opcns.h"
#include "parecido.h"
#include "utf8.h"

int d_dicci = 0;  // 2, ver mas depuracion

// int umbralDiferencia = 1250; 7250?, mejor 1250?  // 250..20000
int umbralDiferencia = 1250;

// --------------------


AspellSpeller * abre_aspell_speller (char * codleng)
{
  AspellSpeller * dicc;
  AspellConfig * di = new_aspell_config ();
  AspellCanHaveError * perr;
  aspell_config_replace (di, "lang", codleng);
  aspell_config_replace (di, "encoding", "utf-8");
  perr = new_aspell_speller (di);
  if (aspell_error_number (perr) != 0) {
    delete_aspell_config (di);
    delete_aspell_can_have_error (perr);
    return NULL;
  }
  dicc = to_aspell_speller (perr);
  delete_aspell_config (di);
  return dicc ;
}

// letras del idioma seleccionado, como utf8
char ** letrasu;
int nletrasu;

int cck = 0;
int mi_aspell_speller_check ( AspellSpeller * dicc, char * pal)
{
  cck ++;
  return aspell_speller_check (dicc, pal, -1);
}

/*
int mi2_aspell_speller_check ( AspellSpeller * dicc, tpalabra palabra)
{
  if (palabra->en_dicc)
    return TRUE;
  else {
    palabra->en_dicc = mi_aspell_speller_check (dicc, palabra->en_claro);
    return palabra->en_dicc;
    }
}
*/

AspellSpeller * dicc1;
Boolean disponeDicc = FALSE;

AspellSpeller * diccs[10];       // ATENCION, al aumentar los idiomas

void abre_diccionarios (char * codleng)
{
  // dicc1 = abre_aspell_speller (codleng);
  disponeDicc = TRUE;
}

Boolean disponiblesDiccionarios ()
{
//  return TRUE;
  return disponeDicc;
}

// --------------------

void limpiaFinParteDePalabra (char * parte)
{
  int ncup;
  char *chult;
  int lu;
  ncup = strlen (parte);
  while (ncup > 0) {
    chult = ultimoUtf8 (parte);
    if ( eschruPuntuacion(chult) ) {
      lu = strlen (chult);
      parte[ncup-lu] = '\0';
      ncup -= lu;
      }
    else
      break;
    }
}

void limpiaComienzoParteDePalabra (char * parte)
{
  int ncpp;
  int i;
  char *chpri;
  int lp;
  ncpp = strlen (parte);
  while (ncpp > 0) {
    chpri = primerUtf8 (parte);
    if ( eschruPuntuacion(chpri) ) {
      lp = strlen (chpri);
      for(i=lp;i<=ncpp;i++)
        parte [i-lp] = parte[i];
      ncpp -= lp;
      }
    else
      break;
    }
}

void limpiaPartesDePalabra (lista partes)
{
  limpiaFinParteDePalabra      ((char *) partes->ultimo->aitem);
  limpiaComienzoParteDePalabra ((char *) partes->primero->aitem);
}


// --------------------

char * letraI (int i, int nl)
{
  char * letr;
  if (i<(nl-1)){
    return letrasu [i];
    } 
  else {                                   // parche
    letr = (char *) malloc(10);
    letr [0] = 'f';   letr[1] = 'l';   letr [2] = '\0';
    return letr;
    } 
}

void strncat2letrI (char *pal1, int i, int nl, char * pal3, int n3)
{
  char *letr;
  letr = letraI (i, nl);
  strncat (pal1, letr, 10);
  // free (letr);                                 // en version 25 y ..
  strncat (pal1, pal3, n3);
}

// --------------- alternativasDiccionario .. ---------------

int alternativasDiccionario1 (lista *nalternativas, lista partes)
{
  int nl = nletrasu +1;
  int i;
  char palabra[210];
  char *letrAlt;
  int nalt = 0;
  lista alternativas;
  lista unaAlternativa;
  alternativas = listaNueva ();
  for (i=0; i<nl; i++) {
    strncpy (palabra, (char *)partes->primero->aitem, 100);
    strncat2letrI (palabra, i, nl, (char *)partes->primero->siguiente->aitem, 100);
    if (mi_aspell_speller_check(dicc1, palabra)){
      unaAlternativa = listaNueva ();
      nalt ++;
      letrAlt = letraI (i, nl);
      aniadeafinlista (unaAlternativa, letrAlt);
      aniadeafinlista (alternativas, unaAlternativa);
      // printf ("/// %3d, %s\n", nalt, palabra);
      }
    }
  *nalternativas = alternativas;
  return nalt;
}

int alternativasDiccionario2 (lista *nalternativas, lista partes)
{
  int nl = nletrasu +1;
  int i;
  int j;
  char palabra[210];
  char *letrAlt;
  char *letrAlt2;
  int nalt = 0;
  lista alternativas;
  lista unaAlternativa;
  alternativas = listaNueva ();
  for (i=0; i<nl; i++)
  for (j=0; j<nl; j++) {
    strncpy (palabra, (char *)partes->primero->aitem, 100);
    strncat2letrI (palabra, i, nl, (char *)partes->primero->siguiente->aitem, 100);
    strncat2letrI (palabra, j, nl,
		    (char *)partes->primero->siguiente->siguiente->aitem, 100);
    if (mi_aspell_speller_check(dicc1, palabra)){
      unaAlternativa = listaNueva ();
      nalt ++;
      letrAlt  = letraI (i, nl);
      letrAlt2 = letraI (j, nl);
      aniadeafinlista (unaAlternativa, letrAlt);
      aniadeafinlista (unaAlternativa, letrAlt2);
      aniadeafinlista (alternativas, unaAlternativa);
      // printf ("/// %3d, %s\n", nalt, palabra);
      }
    }
  *nalternativas = alternativas;
  return nalt;
}

// --------------------

void colocaLetraenIncognita (char *ch, tglifo glifoChar)
{
  ponLetGlifo (glifoChar, ch);
  glifoChar->recon = reconDicc ;
}

void colocaLetraenIncognita2j (char *ch1, char * ch2, tglifo glifoChar)
{
  char chtmp[21], *ch;
  strncpy (chtmp, ch1, 10);
  strncat (chtmp, ch2, 10);
  ch = strdup (chtmp);
  ponLetGlifo (glifoChar, ch);
  glifoChar->recon = reconDicc ;
}

void comparaVentanasdeGlifosFlotx (Boolean *ajuste, int *distancia,
		                   tglifo glifoIncognita, tglifo mlGlifo,
			           Boolean conHolgura, int *posicionx)
{
  tvent ventanadeIncognita, ventanademl;
  int txml, txinc;
  tvent nventanadeIncognita, nventanaGrdeIncognita;
  tvent ventanadeIncognitaCompara;
  int baseIncognita, alturaxIncognita;
  int baseMl, alturaxMl;
  int masAscendenteMl;
  int margen, fondo;
  tdcaracHistoGr carHisGr;
  int dx;
  int diferencia;
  int holgura;
// int nh1;                          //-
//  describeGlifo (glifoIncognita, 0);
//  describeGlifo (mlGlifo, 0);
  *distancia = 1000000000;
  *ajuste = FALSE;
  ventanadeIncognita = glifoIncognita->venDeGlifo;
  ventanademl        = mlGlifo       ->venDeGlifo;
  txml  = ventanademl->tx;
  txinc = ventanadeIncognita->tx;
  holgura = abs(txinc - txml) ;
  // conHolgura  =>    txinc  ~>=  txml,   (aprox. mayor o igual)
  if (! conHolgura || (txml > txinc) )
    if ( max(holgura - 2, 0) * 100 / txml > 10) {
      return;
      }
//  describeVentana (ventanadeIncognita);
//  describeVentana (ventanademl);
  baseyalturaxDeGlifo (& baseIncognita, & alturaxIncognita, glifoIncognita);
  baseyalturaxDeGlifo (& baseMl       , & alturaxMl       , mlGlifo);
  masAscendenteMl = (baseMl - baseIncognita) -
                    (ventanademl->dy - ventanadeIncognita->dy);
  margen = 2 + ventanadeIncognita->tx/20 + ventanadeIncognita->ty/20;
  carHisGr = carhisgrDeVentana (ventanadeIncognita);
  fondo = carHisGr->xblanco ;
//  printf ("masAscendenteMl: %4d, margen: %4d\n", masAscendenteMl, margen);
  ventanaLimpConMargenPara2vents (&nventanadeIncognita, ventanadeIncognita,
		                  ventanademl, -masAscendenteMl, fondo, margen);
  nventanaGrdeIncognita = nventanadeIncognita->venBase;
//  presentaVentana (& nh1, nventanaGrdeIncognita, "sal36a.pgm", 4);
  for (dx=1; dx < (nventanaGrdeIncognita->tx - ventanademl->tx); dx++){
    ventanaEnVentana (&ventanadeIncognitaCompara, nventanaGrdeIncognita, 
		      dx, nventanadeIncognita->dy - masAscendenteMl,
		      ventanademl->tx, ventanademl->ty );
//    describeVentana (nventanaGrdeIncognita);
//    describeVentana (ventanadeIncognitaCompara);
//    describeVentana (ventanademl);
    diferencia = comparaVent (ventanadeIncognitaCompara, ventanademl);
//    printf("------> diferencia: %10d\n", diferencia);
    if (diferencia < umbralDiferencia)
      *ajuste = TRUE;
    if (diferencia < *distancia)
      *distancia = diferencia;
    }
//   presentaVentana (& nh1, ventanadeIncognitaCompara, "sal36a.pgm", 4);
//   presentaVentana (& nh1, ventanademl              , "sal36b.pgm", 4);
//   exit (1);
}

void comparaVentanasdeGlifos (Boolean *ajuste, int *distancia,
		              tglifo glifoIncognita, tglifo mlGlifo)
{
  int nada;
  comparaVentanasdeGlifosFlotx (ajuste, distancia, glifoIncognita, mlGlifo,
			        FALSE, &nada);
}

Boolean mismaLetraenGlifoBasen (tglifo *mlGlifo, char *letra, tglifo glifoIncognita, int tipogBase) 
{
  tglifo glifoLinea;
  lista l;
  glifoLinea = glifoBasenTipo (glifoIncognita, tipogBase); 
  l = listaGlifosConLetraEnGlifo (glifoLinea, letra);
  if (! listaVacia(l)) {
     *mlGlifo = l->primero->aitem ;
    return TRUE;
    }
  else
    return FALSE;
}

// --------------- verosimil ---------------

Boolean verosimil (char *letra, tglifo glifoIncognita)
{
  tglifo mlGlifo;
  Boolean ajuste1gl;
  int distancia1gl;
  Boolean ok = FALSE;
  if (mismaLetraenGlifoBasen (&mlGlifo, letra, glifoIncognita, glifCompLin)) {
    comparaVentanasdeGlifos (&ajuste1gl, &distancia1gl, glifoIncognita, mlGlifo);
    ok = ajuste1gl;
    }
  else if (mismaLetraenGlifoBasen (&mlGlifo, letra, glifoIncognita, glifCompClmp)) {
    comparaVentanasdeGlifos (&ajuste1gl, &distancia1gl, glifoIncognita, mlGlifo);
    ok = ajuste1gl;
    }
  return ok;
}

Boolean verosimil2j (char *letra1, char *letra2, tglifo glifoIncognita)
{
  tglifo mlGlifo1;
  tglifo mlGlifo2;
  Boolean ajuste1gl1;
  Boolean ajuste1gl2;
  int distancia1gl1;
  int distancia1gl2;
  int posx1, posx2;
  Boolean ok = FALSE;
  if (mismaLetraenGlifoBasen (&mlGlifo1, letra1, glifoIncognita, glifCompLin) &&
      mismaLetraenGlifoBasen (&mlGlifo2, letra2, glifoIncognita, glifCompLin)) {
    comparaVentanasdeGlifosFlotx (&ajuste1gl1, &distancia1gl1,
		    glifoIncognita, mlGlifo1, TRUE, &posx1);
    comparaVentanasdeGlifosFlotx (&ajuste1gl2, &distancia1gl2,
		    glifoIncognita, mlGlifo2, TRUE, &posx2);
    ok = ajuste1gl1 && ajuste1gl2 ;
    }
  else if (mismaLetraenGlifoBasen (&mlGlifo1, letra1, glifoIncognita, glifCompClmp) &&
           mismaLetraenGlifoBasen (&mlGlifo2, letra2, glifoIncognita, glifCompClmp)) {
    comparaVentanasdeGlifosFlotx (&ajuste1gl1, &distancia1gl1,
		    glifoIncognita, mlGlifo1, TRUE, &posx1);
    comparaVentanasdeGlifosFlotx (&ajuste1gl2, &distancia1gl2,
		    glifoIncognita, mlGlifo2, TRUE, &posx2);
    ok = ajuste1gl1 && ajuste1gl2 ;
    }
  return ok;
}

int conVer2s=0;          // para contar uso?

Boolean verosimil2s (char *letra1, char *letra2,
		     tglifo glifoIncognita1, tglifo glifoIncognita2)
{
  tglifo mlGlifo1;
  tglifo mlGlifo2;
  Boolean ajuste1gl1;
  Boolean ajuste1gl2;
  int distancia1gl1;
  int distancia1gl2;
  Boolean ok = FALSE;
  if (mismaLetraenGlifoBasen (&mlGlifo1, letra1, glifoIncognita1, glifCompLin) &&
      mismaLetraenGlifoBasen (&mlGlifo2, letra2, glifoIncognita2, glifCompLin)) {
    comparaVentanasdeGlifos (&ajuste1gl1, &distancia1gl1,
		             glifoIncognita1, mlGlifo1);
    comparaVentanasdeGlifos (&ajuste1gl2, &distancia1gl2,
		             glifoIncognita2, mlGlifo2);
    ok = ajuste1gl1 && ajuste1gl2 ;
    }
  else if (mismaLetraenGlifoBasen (&mlGlifo1, letra1, glifoIncognita1, glifCompClmp) &&
           mismaLetraenGlifoBasen (&mlGlifo2, letra2, glifoIncognita2, glifCompClmp)) {
    comparaVentanasdeGlifos (&ajuste1gl1, &distancia1gl1,
		             glifoIncognita1, mlGlifo1);
    comparaVentanasdeGlifos (&ajuste1gl2, &distancia1gl2,
		             glifoIncognita2, mlGlifo2);
    ok = ajuste1gl1 && ajuste1gl2 ;
    }
  return ok;
}

lista partesDosIncognitasJuntas (lista partes)
{
  lista lis;
  char * tiravacia;
  lis = copiaLista (partes);
  tiravacia = strdup ("");
  aniadealistaAntes (lis, tiravacia, lis->primero->siguiente);
  return lis;
}

// --------------- encuentra incognita(s) ---------------
// Boolean encuentra....incognita.paraPalabra (tglifo glifoPal)
//   nalt = alternativasDiccionario. (&alternativas, partes.);              // 1
//   if (nalt >= 1) {
//       if (verosimil.. (letra1, letra2, glifoIncognita)){                 // 2
//     if (candidatasB == 1){
//       colocaLetraenIncognita.. (letra1B, letra2B, glifoIncognita);       // 3

Boolean encuentra1incognitaparaPalabra (tglifo glifoPal)
{
  tglifo glifoIncognita;
  lista partes;
  lista alternativas;
  int nalt;
  lista listaIncognitas;
  int candidatasB;
  partes = partesDePalabraLenGlifo (glifoPal); 
  limpiaPartesDePalabra (partes);
  if ((strlen((char *)partes->primero->aitem) == 0) &&
      (strlen((char *)partes->primero->siguiente->aitem) == 0))
    return TRUE;
  nalt = alternativasDiccionario1 (&alternativas, partes);
  if (d_valori+d_dicci >= 6){
    escribePalabradeGlifoL (glifoPal);
    printf (">> %3d\n", nalt);
    }
  listaIncognitas = listaIncognitasEnGlifoL (glifoPal);
  glifoIncognita = (tglifo) listaIncognitas->primero->aitem;
  if (nalt >= 1) {
    char *letra;
    char *letraB;
    candidatasB = 0;
    tnodol nl;
    for (nl=alternativas->primero; nl!=0L; nl=nl->siguiente){
      letra = (char *) ((lista)nl->aitem)->primero->aitem ;
      if (d_valori+d_dicci >= 6)
        printf (">>- %s\n", letra);
      if (verosimil (letra, glifoIncognita)){
        candidatasB ++;
        letraB = letra;
        }
      }
    if (candidatasB == 1){
      colocaLetraenIncognita (letraB, glifoIncognita);
      if (d_valori+d_dicci >= 5)
        printf (">>>> %s\n", letraB);
      }
    }
  return (nalt > 0) && (candidatasB > 0);
}

Boolean encuentra2junincognitasparaPalabra (tglifo glifoPal)
{
  tglifo glifoIncognita;
  lista partes;
  lista alternativas;
  int nalt;
  lista listaIncognitas;
  int candidatasB;
  lista partes2;
  partes = partesDePalabraLenGlifo (glifoPal); 
  limpiaPartesDePalabra (partes);
  partes2 = partesDosIncognitasJuntas (partes);
  // atencion, este codigo esta CASI duplicado mas abajo (partes2)
  nalt = alternativasDiccionario2 (&alternativas, partes2);
  if (d_valori+d_dicci >= 5){
    escribePalabradeGlifoL (glifoPal);
    printf ("=> %3d\n", nalt);
    }
  listaIncognitas = listaIncognitasEnGlifoL (glifoPal);
  glifoIncognita = (tglifo) listaIncognitas->primero->aitem;
  if (nalt >= 1) {
    char *letra1, *letra2;
    char *letra1B, *letra2B;
    tnodol nl;
    candidatasB = 0;
    if (d_valori+d_dicci >= 6)
      printf ("=>-");
    for (nl=alternativas->primero; nl!=0L; nl=nl->siguiente){
      letra1 = (char *) ((lista)nl->aitem)->primero->aitem ;
      letra2 = (char *) ((lista)nl->aitem)->primero->siguiente->aitem ;
      if (d_valori+d_dicci >= 6)
        printf (" %s %s,", letra1, letra2);
      }
    if (d_valori+d_dicci >= 6)
      printf ("\n");
    for (nl=alternativas->primero; nl!=0L; nl=nl->siguiente){
      letra1 = (char *) ((lista)nl->aitem)->primero->aitem ;
      letra2 = (char *) ((lista)nl->aitem)->primero->siguiente->aitem ;
      if (verosimil2j (letra1, letra2, glifoIncognita)){
        if (d_valori+d_dicci >= 6)
          printf (" verosimil2j: %s %s\n", letra1, letra2);
        candidatasB ++;
        letra1B = letra1;
        letra2B = letra2;
        }
      }
    if (candidatasB == 1){
      colocaLetraenIncognita2j (letra1B, letra2B, glifoIncognita);
      if (d_valori+d_dicci >= 5)
        printf ("=>>>> %s %s\n", letra1B, letra2B);
      }
    }
//
  return (nalt > 0) && (candidatasB > 0);
}

Boolean encuentra2sepincognitasparaPalabra (tglifo glifoPal)
{
  tglifo glifoIncognita1, glifoIncognita2;
  lista partes;
  lista alternativas;
  int nalt;
  lista listaIncognitas;
  int candidatasB;
  partes = partesDePalabraLenGlifo (glifoPal); 
  limpiaPartesDePalabra (partes);
  if ((strlen((char *)partes->primero->aitem) == 0) &&
      (strlen((char *)partes->primero->siguiente->aitem) == 0) &&
      (strlen((char *)partes->primero->siguiente->siguiente->aitem) == 0) )
    return TRUE;
//
  nalt = alternativasDiccionario2 (&alternativas, partes);
  if (d_valori+d_dicci >= 5){
    escribePalabradeGlifoL (glifoPal);
    printf ("=> %3d\n", nalt);
    }
  listaIncognitas = listaIncognitasEnGlifoL (glifoPal);
  glifoIncognita1 = (tglifo) listaIncognitas->primero->aitem;
  glifoIncognita2 = (tglifo) listaIncognitas->primero->siguiente->aitem;
  if (nalt >= 1) {
    char *letra1, *letra2;
    char *letra1B, *letra2B;
    tnodol nl;
    candidatasB = 0;
    if (d_valori+d_dicci >= 6)
      printf ("=>-");
    for (nl=alternativas->primero; nl!=0L; nl=nl->siguiente){
      letra1 = (char *) ((lista)nl->aitem)->primero->aitem ;
      letra2 = (char *) ((lista)nl->aitem)->primero->siguiente->aitem ;
      if (d_valori+d_dicci >= 6)
        printf (" %s %s,", letra1, letra2);
      }
    if (d_valori+d_dicci >= 6)
      printf ("\n");
    for (nl=alternativas->primero; nl!=0L; nl=nl->siguiente){
      letra1 = (char *) ((lista)nl->aitem)->primero->aitem ;
      letra2 = (char *) ((lista)nl->aitem)->primero->siguiente->aitem ;
      if (verosimil2s (letra1, letra2, glifoIncognita1, glifoIncognita2)){    // 2
        if (d_valori+d_dicci >= 6)
          printf (" verosimil2s: %s %s\n", letra1, letra2);
        candidatasB ++;
        letra1B = letra1;
        letra2B = letra2;
        }
      }
    if (candidatasB == 1){
      colocaLetraenIncognita (letra1B, glifoIncognita1);
      colocaLetraenIncognita (letra2B, glifoIncognita2);
      if (d_valori+d_dicci >= 5)
        printf ("=|>>>> %s %s\n", letra1B, letra2B);
      }
    }
//
  return (nalt > 0) && (candidatasB > 0);
}

// Si quitando incognita esta en el diccionario
//   y parece mancha
//     ... y  no se junta con letra cercana  // pendiente
// quitar y -> bien.
Boolean incognitaEsManchaEnPalabra (tglifo glifoPal)
{
  lista partes;
  lista listaIncognitas;
  tglifo glifoIncognita;
  tvent  ventIncognita;
  char palabra1[101];
  // partes de palabra
    // printf ("--->incognitaEsManchaEnPalabra\n");
    // escribePalabradeGlifoL (glifoPal);
    // describeGlifo(glifoPal, 2);
    // printf ("\n");
  partes = partesDePalabraLenGlifo (glifoPal); 
  limpiaPartesDePalabra (partes);
  listaIncognitas = listaIncognitasEnGlifoL (glifoPal);
  // concatenarlas
  strncpy (palabra1, (char *) partes->primero->aitem, 50);
  strncat (palabra1, (char *) partes->primero->siguiente->aitem, 50);
  // esta en diccionario ?
  if (!mi_aspell_speller_check(dicc1, palabra1))
    // no -> mal
    return FALSE;
  //  // y parece mancha
  // si -> quitar incognita de glifo palabra
  glifoIncognita = listaIncognitas->primero->aitem;
  ventIncognita = glifoIncognita->venDeGlifo;
  if ((ventIncognita->tx <= 5) && (ventIncognita->ty <= 5)) { // mejorar
    glifoIncognita->tipo = glifArtf;
    quitadeArboles (glifoIncognita);
      // printf ("--->incognitaEsManchaEnPalabra 2\n");
      // escribePalabradeGlifoL (glifoPal);
      // describeGlifo(glifoPal, 2);
      // printf ("\n");
    return TRUE;
    }
  else
  return FALSE;
}

// --------------- === ---------------

Boolean todoCifras (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  lp = strlen (palabra);
  // cifras: 48..57,   utf8: un octeto. vale.
  for (i=0; i<lp; i++)
    if ((palabra[i] < '0') || (palabra[i] > '9'))
      return FALSE;
  return TRUE;
}

// pendiente:  que no sea 10 (1o),
//     que '1' y 'l' sean bastante parecidos, ...
//     que necesita varios cambios, ...
Boolean letrasyUnos (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  char *palabra2;
  char *chi;
  Boolean cambio = FALSE;
  lp = strlen (palabra);
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if (strcmp (chi, "1") == 0){
      strcat (palabra2, "l");
      cambio = TRUE;
      }
    else if (! esLetra(chi) )
      return FALSE ;
    else
      strcat (palabra2, chi);
    i += strlen (chi);
    }
  if (! cambio)
    return FALSE;
  if (!mi_aspell_speller_check(dicc1, palabra2))
    return FALSE;
  // cambiar '1' por 'l'
  cambiaNEnGlifo (glifoPal, '1', 'l');              //
  return TRUE;
}

// si hay  palabra1 'guion' palabra2
// y  ambase estan en el diccionario -> bien.
Boolean palGuionPal (tglifo glifoPal)
{
  int i, lp ;
  char *palabra = glifoPal->letras;
  char *palabra1;
  char *palabra2;
  char *chi;
  Boolean hayguion = FALSE;
  lp = strlen (palabra);
  palabra1 = (char *) malloc (3 * lp);
  palabra1[0] = '\0';
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if (strcmp (chi, "-") == 0){
      hayguion = TRUE;
      }
    else if (!hayguion)
      strcat (palabra1, chi);
    else
      strcat (palabra2, chi);
    i += strlen (chi);
    }
  if (! hayguion)
    return FALSE;
  // printf ("== %s %s\n", palabra1, palabra2);
  if ((!mi_aspell_speller_check(dicc1, palabra1)) ||
      (!mi_aspell_speller_check(dicc1, palabra2)) )
    return FALSE;
  // libera memoria  palabra1
  // libera memoria  palabra2
  return TRUE;
}

//    mientras las cifras y la 'l'  estan en un octeto ... vale
// si hay cifras 2..9 y 'l'
// cambiar eles por unos
Boolean cifrasyEles (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  Boolean cambio = FALSE;
  Boolean cifras = FALSE;
  lp = strlen (palabra);
  for (i=0; i<lp; i++) {
    if (palabra[i] == 'l')
      cambio = TRUE;
    else if ((palabra[i] > '9') || (palabra[i] < '0'))
      return FALSE ;
    else if ((palabra[i] <= '9') && (palabra[i] >= '2'))
      cifras = TRUE;
    }
  if (! cambio || !cifras)
    return FALSE;
  // cambiar 'l' por '1'
  cambiaNEnGlifo (glifoPal, 'l', '1');
  return TRUE;
}

Boolean mayusculaTrasMinuscula (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  char *palabra2;
  char *chi;
  char ch[128];    
  lp = strlen (palabra);
  Boolean cambio = FALSE;
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if ( (i > 0) && esMayuscula(chi) ){
      minusdeMayus (ch, chi);
      strcat (palabra2, ch);
      // printf ("5---///%c %c\n", palabra[i], palabra2[i]);  //
      // printf ("6---///%s\n", palabra2);                    //
      cambio = TRUE;
      }
    else if (! esLetra(chi) )
      return FALSE ;
    else
      strcat (palabra2, chi);
    i += strlen (chi);
    }
  if (! cambio)
    return FALSE;
  if (!mi_aspell_speller_check(dicc1, palabra2))
    return FALSE;
  // cambiar de mayus a minus
  // printf ("---///3>\n");    //
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if ( (i > 0) && esMayuscula(chi) ){
      minusdeMayus (ch, chi);
      cambiaStrNEnGlifo (glifoPal, chi, ch);
      }
    i += strlen (chi);
    }
  return TRUE;
}

Boolean minusculaTrasMayuscula (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  char *palabra2;
  char *chi;
  char ch[128];
  lp = strlen (palabra);
  Boolean cambio = FALSE;
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if ( (i > 0) && esMinuscula(chi) ){
      mayusdeMinus (ch, chi);
      strcat (palabra2, ch);
  //    printf ("---///%c %c\n", palabra[i], palabra2[i]);  //
  //    printf ("---///%s\n", palabra2);                    //
      cambio = TRUE;
      }
    else if (! esLetra(chi) )
      return FALSE ;
    else
      strcat (palabra2, chi);
    i += strlen (chi);
    }
  if (! cambio)
    return FALSE;
  if (!mi_aspell_speller_check(dicc1, palabra2))
    return FALSE;
  // cambiar de minus a mayus
  // printf ("---///3>\n");  //
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if ( (i > 0) && esMinuscula(chi) ){
      mayusdeMinus (ch, chi);
      cambiaStrNEnGlifo (glifoPal, chi, ch);
      }
    i += strlen (chi);
    }
  return TRUE;
}

// - mayuscula despues de minusculas (S O ...)    piSo
// - minuscula despues de mayusculas (s o ...)    VENDo
Boolean mayusculaTrasMinusculaOvice (tglifo glifoPal)
{
  Boolean conMayusculas;  // .. definidas y quiza minusculas ambiguas
  Boolean conMinusculas; 
  int i, lp;
  char *palabra = glifoPal->letras;
  char *chi;
  lp = strlen (palabra);
  if (lp == 1)
    return FALSE;
  conMayusculas = FALSE;
  conMinusculas = FALSE;
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if ((i > 0) && esMayuscula(chi) && !esAmbigua1 (chi) )
      conMayusculas = TRUE;
    if (           esMinuscula(chi) && !esAmbigua2 (chi) )
      conMinusculas = TRUE;
    i += strlen (chi);
    }
  // printf ("---///>%3d %3d %s\n", conMayusculas, conMinusculas, palabra); //
  if (conMayusculas && conMinusculas)
    return FALSE;
  if (!conMayusculas && !conMinusculas)
    return FALSE;
  if (conMayusculas)   //  && !conMinusculas
    return minusculaTrasMayuscula (glifoPal);
   // if (conMinusculas)   //  && !conMayusculas
    return mayusculaTrasMinuscula (glifoPal);
}

//    mientras 'I' y la 'l'  estan en un octeto ... apao
// - I en lugar de l (ele)                        calIe
Boolean imayusEnlugardeEle (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  char *palabra2;
  char *chi;
  Boolean cambio = FALSE;
  lp = strlen (palabra);
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if (palabra[i] == 'I'){
      palabra2[i] = 'l';
      cambio = TRUE;
      }
    else if (! esLetra(chi) )
      return FALSE ;
    i += strlen (chi);
    }
  if (! cambio)
    return FALSE;
  if (!mi_aspell_speller_check(dicc1, palabra2))
    return FALSE;
  // cambiar 'I' por 'l'
  cambiaNEnGlifo (glifoPal, 'I', 'l');
  return TRUE;
}

//    mientras '|' y la 'l'  estan en un octeto ... apao
// - | en lugar de l (ele)                        cal|e
Boolean pipeEnlugardeEle (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  char *palabra2;
  char *chi;
  Boolean cambio = FALSE;
  lp = strlen (palabra);
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if (palabra[i] == '|'){
      palabra2[i] = 'l';
      cambio = TRUE;
      }
    else if (! esLetra(chi) ){
      if (d_valori+d_dicci >= 6)
        printf ("------>>%c %s\n", palabra[i], palabra);
      return FALSE ;
      }
    i += strlen (chi);
    }
  if (! cambio)
    return FALSE;
  if (d_valori+d_dicci >= 6)
    printf ("==->%s %s\n", palabra, palabra2);
  if (!mi_aspell_speller_check(dicc1, palabra2))
    return FALSE;
  // cambiar '|' por 'l'
  cambiaNEnGlifo (glifoPal, '|', 'l');
  return TRUE;
}

//    mientras 'I', '|' y la 'l'  estan en un octeto ... apao
// - I  y | en lugar de l (ele)                   ca|Ie
Boolean imayusyPipeEnlugardeEle (tglifo glifoPal)
{
  int i, lp;
  char *palabra = glifoPal->letras;
  char *palabra2;
  char *chi;
  Boolean cambio = FALSE;
  lp = strlen (palabra);
  palabra2 = (char *) malloc (3 * lp);
  palabra2[0] = '\0';
  i = 0;
  while (i<lp) {
    chi = primerUtf8 (& (palabra[i]));
    if ((palabra[i] == '|') ||
        (palabra[i] == 'I')){
      palabra2[i] = 'l';
      cambio = TRUE;
      }
    else if (! esLetra(chi) ){
      if (d_valori+d_dicci >= 6)
        printf ("------>>%c %s\n", palabra[i], palabra);
      return FALSE ;
      }
    i += strlen (chi);
    }
  if (! cambio)
    return FALSE;
  printf ("==->%s %s\n", palabra, palabra2);
  if (!mi_aspell_speller_check(dicc1, palabra2))
    return FALSE;
  // cambiar '|' e 'I' por 'l'
  cambiaNEnGlifo (glifoPal, '|', 'l');
  cambiaNEnGlifo (glifoPal, 'I', 'l');
  return TRUE;
}

//// - mancha fuera (encima, debajo?) de letra      salu.d
//Boolean manchaFueraDeLetra (tglifo glifoPal)
//{
//  return FALSE;
//}


// --------------- === ---------------

int nna = 0;

void repasaPalabraCompleta (tglifo glifoPal)
{
  lista partes;
  char * palabra;
  Boolean bien;
  if (glifoPal->parteLogAnt == 0L) {         // este if sobra?
    partes = partesDePalabraLenGlifo (glifoPal);
    limpiaPartesDePalabra (partes);
    palabra = (char *)partes->primero->aitem ;
    if (! mi_aspell_speller_check(dicc1, palabra)){
      glifoPal->letras = palabra;
      bien = FALSE;
      // - todo cifras                                  82   (pag)
      if (!bien) bien = todoCifras (glifoPal);
      //
      // - letras y unos                                cal1e
      if (!bien) bien = letrasyUnos (glifoPal);
      //
      // -  palabra -guion- palabra                     horse-doctor
      if (!bien) bien = palGuionPal (glifoPal);
      //
      // - cifras y eles                                432l0 (2 ele 0)
      if (!bien) bien = cifrasyEles (glifoPal);
      //
      // - mayuscula despues de minusculas (S O ...)    piSo
      // - minuscula despues de mayusculas (s o ...)    VENDo
      if (!bien) bien = mayusculaTrasMinusculaOvice (glifoPal);
      //
      // - I en lugar de l (ele)                        calIe
      if (!bien) bien = imayusEnlugardeEle (glifoPal);
      //
      // - | en lugar de l (ele)                        cal|e
      if (!bien) bien = pipeEnlugardeEle (glifoPal);
      //
      // - I  y | en lugar de l (ele)                   ca|Ie
      if (!bien) bien = imayusyPipeEnlugardeEle (glifoPal);
      //
      // - mancha fuera (encima, debajo?) de letra      salu.d
      // if (!bien) bien = manchaFueraDeLetra (glifoPal);
      //
      // - nombre Propiopersona                         Juan
      // if (!bien) bien = nombrePropiopersona (glifoPal);
      //
      // - nombres de Lugares                           Madrid
      // if (!bien) bien = nombredeLugar (glifoPal);
      //
      // - parece nombre propio                         Xyzwxy
      // if (!bien) bien = pareceNombrePropio (glifoPal);
      //
      // - otro idioma ?                                help
      // if (!bien) bien = otroIdioma (glifoPal);
      //
      // printf ("--no aspell-->>");
      if (d_valori+d_dicci >= 4)
        if (! bien) {
          printf ("--no aspell--%4d ->> ", ++nna);
          printf ("%s ", palabra);
	  escribePalabradeGlifoL (glifoPal);
          }
      // escribe palabra en diccionario eventual o local
      // separar palabras ?
      // juntar palabras ?
      }
    }
}
  
// --------------- === ---------------

void repasaPalabraConDiccionario (tglifo glifoPal)
{ 
  Boolean bien;
  int nincog ;
  enlazaPalabraPartida (glifoPal);          // sobra?
  nincog = nincognitasEnLGlifo (glifoPal) ;
  if (nincog == 0)
    repasaPalabraCompleta (glifoPal);
  if (nincog > 0){
    if (d_valori+d_dicci >= 5){
      printf ("% 3d ", nincog) ;
      escribePalabradeGlifo (glifoPal);
      }
    }
  if (nincog == 1) {
    bien = encuentra1incognitaparaPalabra (glifoPal);
    if (!bien) bien = encuentra2junincognitasparaPalabra (glifoPal);
    if (!bien) bien = incognitaEsManchaEnPalabra (glifoPal);
    }
  if (nincog == 2)
    encuentra2sepincognitasparaPalabra (glifoPal);
  if (nincog >= 3)
    if (d_valori+d_dicci >= 4)
      printf("3 o mas incognitas: %2d\n", nincog);
}


// --------------- === ---------------

void utilizaDiccionarios (tglifo glifoColumnaP)
{
  aplicaGtRFn (glifoColumnaP, glifCompPal, repasaPalabraConDiccionario);
}

// --------------- elige ---------------

void eligeDiccionarios (tglifo glifoColumnaP)
{
  lista l;
  tnodol nodol;
  int i;
  int j;
  tglifo glifoPal;
  int nincog ;
  lista partes ;
  char * palabra;
  int nid = 10;                                      //
  int nd [10] = {0,0,0,0,0,0,0,0,0,0} ;              //
  int len;
  listadePalabrasLenGlifo (&l , glifoColumnaP);
  diccs[0] = abre_aspell_speller ("es_ES");
  diccs[1] = abre_aspell_speller ("en_EN");
  diccs[2] = abre_aspell_speller ("ca_ES");
  diccs[3] = abre_aspell_speller ("fr_FR");
  diccs[4] = abre_aspell_speller ("pt_PT");
  diccs[5] = abre_aspell_speller ("pl_PL");  
  diccs[6] = abre_aspell_speller ("de_DE");  
  diccs[7] = abre_aspell_speller ("ru_RU");  
  diccs[8] = abre_aspell_speller ("eo_EO");  
  diccs[9] = abre_aspell_speller ("eu_ES");  
//  diccs[6] = abre_aspell_speller ("xx_DE");  
  for (nodol = l->primero, i=0; (nodol != 0L) && (i<12);  // 12
                 nodol = nodol->siguiente) {
    glifoPal = (tglifo) nodol->aitem;
    nincog = nincognitasEnGlifo (glifoPal) ;
    if (nincog == 0) {
      partes = partesDePalabraLenGlifo (glifoPal);
      limpiaPartesDePalabra (partes);
      palabra = (char *)partes->primero->aitem ;
      if (strlen(palabra) > 1){
        i ++;
        // printf ("==>> %s\n", palabra);
        for (j=0;j<nid;j++){
          if (diccs[j] != NULL)
            if (mi_aspell_speller_check(diccs[j], palabra)){
              nd[j]++ ;
	//      printf ("+");
              }
	//    else
        //      printf (".");
            }
        // printf (" ==>> %s\n", palabra);
        }
      }
    }
  if (d_valori+d_dicci >= 4)
    printf (" es:%2d, en:%2d, ca:%2d, fr:%2d, pt:%2d, pl:%2d, de:%2d, ru:%2d, eo:%2d, eu:%2d\n",
               nd[0],  nd[1],  nd[2],  nd[3],  nd[4],  nd[5],  nd[6],  nd[7],  nd[8],  nd[9]);
  len = posmaxv (nd, nid);
  dicc1 = diccs[len];
  if (len == 0) {
    letrasu = letrasu_es;
    nletrasu = nletras_es;
    }
  else if (len == 1) {
    letrasu = letrasu_en;
    nletrasu = nletras_en;
    }
  else if (len == 2) {
    letrasu = letrasu_ca;
    nletrasu = nletras_ca;
    }
  else if (len == 3) {
    letrasu = letrasu_fr;
    nletrasu = nletras_fr;
    }
  else if (len == 4) {
    letrasu = letrasu_pt;
    nletrasu = nletras_pt;
    }
  else if (len == 5) {
    letrasu = letrasu_pl;
    nletrasu = nletras_pl;
    }
  else if (len == 6) {
    letrasu = letrasu_de;
    nletrasu = nletras_de;
    }
  else if (len == 7) {
    letrasu = letrasu_ru;
    nletrasu = nletras_ru;
    }
  else if (len == 8) {
    letrasu = letrasu_eo;
    nletrasu = nletras_eo;
    }
  else if (len == 9) {
    letrasu = letrasu_eu;
    nletrasu = nletras_eu;
    }
  else {
    letrasu = letrasu_eo;
    nletrasu = nletras_eo;
    }
}

