
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "atributos.h"
#include "base.h"
// #include "glifos.h"
// #include "grises.h"
#include "grises0.h"
#include "imag.h"
// #include "inclfont.h"
#include "inclina0.h"
#include "lista.h"
#include "opcns.h"

#define NIL (0L)

int fondoClaroFijo (tvent vent)
{
  return 164;                  // 192, 144
}

int nvents = 0;
int nimags = 0;

int (*fondoClaro) (tvent) = fondoClaroFijo ;

timagf imagfalloc ()
{
  timagf imagf;
  imagf = (timagf) malloc (sizeof(struct teimagf));
  imagf->tx   = 0;
  imagf->ty   = 0;
  imagf->ncap = 1;
  imagf->ngr  = 256;
  imagf->apixels  = (char *) NIL;
  imagf->ncom  = 0;
  imagf->comen = (char **) NIL;
  imagf->niv   = 0;
  imagf->base = imagf;
  imagf->red2 = (timagf) NIL;
  imagf->ven0 = (tvent) NIL;
  imagf->venOrig = (tvent) NIL;
  imagf->nf   = (char *) NIL;
  imagf->nid  = ++nimags;
  return imagf;
}

tvent ventalloc ()
{
  tvent vent;
  vent = (tvent) malloc (sizeof(struct tevent));
  vent->lvint      = listaNueva ();
  vent->atributs   = listaNueva ();
  vent->nid        = ++nvents;
           // if (vent->nid == 34846)
           //    printf ("----------- ventalloc -> nid\n");
  return vent;
}

int ntventanas ()
{
  return nvents;
}

tvent ventBaseDeImagf (timagf imagf)
{
  tvent vent;
  int tx, ty, y;
  int ncap;
  char ** v;
  ncap             = imagf->ncap;
  vent = ventalloc ();
  vent->tx         = imagf->tx;
  vent->ty         = imagf->ty;
  vent->dx         = 0;
  vent->dy         = 0;
 // borrar jue dic 11 18:33:03 CET 2008     +30 dias
  // vent->listaVint  = (tvvents) 0L;
  // vent->glifoDeVen = (tglifo) 0L;
  vent->abstract   = 0L;
  vent->carHisGr   = (struct tcaracHistoGr *) 0L;
  vent->conv       = (int *) 0L;
  vent->ktam       = -1;
  vent->venlimpia  = (tvent) 0L;
  vent->incl       =  0;
  /**/
  tx = imagf->tx;
  ty = imagf->ty;
  v = (char **) malloc (ty * sizeof(char *));
  if (v == 0) {
    printf("imag.ventBaseDeImagf, ERROR: Out of memory\n");
    exit (1);
    }
  for(y=0; y<ty; y++)
    v[y] = & (imagf->apixels[y*tx*ncap]) ;
  vent->pix     = v;
  /**/
  vent->imaBase = imagf;
  vent->venBase = vent;
  return vent;
}

void invierteGrImagen (tvent vent)
{
  int tx, ty, x, y;
  char ** pix;
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = 255 - (pix[y][x] & 0x0FF) ;
    }
}

// aplica la funcion   conv  a cada pixel
void cambiaGrImagen (tvent vent, int *conv)
{
  int tx, ty, x, y;
  char ** pix;
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = conv[(pix[y][x] & 0x0FF)] ;
    }
}

Boolean cabeRectanguloEnVentana (tvent vent, 
                                 int dx, int dy, int tx, int ty)
{
  return ((dx >= 0) && (dy >= 0) &&
          (dx+tx <= vent->tx) &&
          (dy+ty <= vent->ty)  ) ;
}

void rectanguloGrisEnVentana (tvent vent,
                              int dx, int dy, int tx, int ty, int gr)
{
  int x, y;
  int dxmtx, dymty;
  int xmax, ymax;
  char ** pix;
  // printf ("rectanguloGrisEnVentana %4d %4d %4d %4d\n", dx, dy, tx, ty);
  dxmtx = dx + tx;
  dymty = dy + ty;
  xmax = min(dxmtx, vent->tx);
  ymax = min(dymty, vent->ty);
  pix  = vent->pix ;
  for (y=dy; y<ymax; y++)
  for (x=dx; x<xmax; x++) {
    pix[y][x] = gr ;
    }
}

void creaImagenVacia (timagf *nimag, int tx, int ty)
{
  timagf imag;
  int tam;
  imag = imagfalloc ();
  imag->tx      = tx ;
  imag->ty      = ty ;
  tam = tx * ty ;
  imag->apixels = (char *) malloc (tam * sizeof(char)) ;
  imag->ven0    = ventBaseDeImagf (imag);
  /**/
  *nimag = imag ;
}

void creaImagenPlana (timagf *nimag, int g, int tx, int ty)
{
  timagf imag;
  // int tam;
  creaImagenVacia (&imag, tx, ty);
  rectanguloGrisEnVentana (imag->ven0, 0, 0, tx, ty, g);
  *nimag = imag ;
}

void creaImagenReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry)
{
  timagf imagr;
  timagf imagv;
  int txr, tyr, xr, yr, tam;
  int ncap;
  int xr2, yr2;
  int k, kr2;
  int dx, dy;
  int nc;
  int sum;
  char ** pix, ** pixr;
  imagv = vent->imaBase ;
  ncap    = imagv->ncap;
  // printf ("ncap: %3d\n", ncap);
  imagr = imagfalloc ();
  imagr->tx      = vent->tx / rx ;
  imagr->ty      = vent->ty / ry ;
  imagr->ncap    = imagv->ncap;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr * ncap;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagr->ncom    = imagv->ncom ;
  imagr->comen   = imagv->comen ;
  imagr->niv     = imagv->niv + 1 ;
  imagr->base    = imagv->base ;
  imagr->nf      = imagv->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  pixr = imagr->ven0->pix ;
  pix  = vent->pix ;
  k   = rx * ry ;
  kr2 = k / 2;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * rx ;
    yr2 = yr * ry ;
    if (ncap == 1) {
      sum = 0 ;
      for (dx = 0; dx < rx; dx++)
      for (dy = 0; dy < ry; dy++) {
        sum += ( pix[yr2+dy][xr2+dx]   & 0x0FF ) ;
        }
      pixr [yr][xr] = ( sum + kr2 ) / k ;
      }
    else {   // ncap > 1
      for (nc=0; nc<ncap; nc++) {
        sum = 0 ;
        for (dx = 0; dx < rx; dx++)
        for (dy = 0; dy < ry; dy++) {
          sum += ( pix[yr2+dy][(xr2+dx)*ncap+nc]  & 0x0FF ) ;
          }
        pixr [yr][xr*ncap+nc] = ( sum + kr2 ) / k ;
        }
      }
    }
  *nimagr = imagr;
}

void creaImagenMaxsReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry)
{
  timagf imagr;
  timagf imagv;
  int txr, tyr, xr, yr, tam;
  int xr2, yr2;
  int dx, dy;
  int maxgr;
  char ** pix, ** pixr;
  imagr = imagfalloc ();
  imagr->tx      = vent->tx / rx ;
  imagr->ty      = vent->ty / ry ;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr ;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagv = vent->imaBase ;
  imagr->ncom    = imagv->ncom ;
  imagr->comen   = imagv->comen ;
  imagr->niv     = imagv->niv + 1 ;
  imagr->base    = imagv->base ;
  imagr->nf      = imagv->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  pixr = imagr->ven0->pix ;
  pix  = vent->pix ;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * rx ;
    yr2 = yr * ry ;
    maxgr = 0 ;
    for (dx = 0; dx < rx; dx++)
    for (dy = 0; dy < ry; dy++) {
      int g;
      g = pix[yr2+dy][xr2+dx] & 0x0FF;
      maxgr = max(g,maxgr) ;
      }
    pixr [yr][xr] = maxgr ;
    }
  *nimagr = imagr;
}

void creaImagenReducida (timagf *nimagr, timagf imag)
{
  timagf imagr;
  int txr, tyr, xr, yr, tam;
  int xr2, yr2;
  char ** pix, ** pixr;
  imagr = imagfalloc ();
  imagr->tx      = imag->tx / 2 ;
  imagr->ty      = imag->ty / 2 ;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr ;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagr->ncom    = imag->ncom ;
  imagr->comen   = imag->comen ;
  imagr->niv     = imag->niv + 1 ;
  imagr->base    = imag->base ;
  imag ->red2    = imagr ;
  imagr->nf      = imag->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  /**/
  pixr = imagr->ven0->pix ;
  pix  = imag->ven0->pix ;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * 2 ;
    yr2 = yr * 2 ;
    pixr[yr][xr] = (
      ( pix[yr2][xr2]     & 0x0FF ) +
      ( pix[yr2][xr2+1]   & 0x0FF ) +
      ( pix[yr2+1][xr2]   & 0x0FF ) +
      ( pix[yr2+1][xr2+1] & 0x0FF ) + 2) / 4;
    }
  *nimagr = imagr;
}

void creaImagenesReducidas (timagf *vimagr, timagf imag, int n)
{
  int i;
  vimagr[0] = imag ;
  for (i=0; i<n; i++)
    creaImagenReducida ( &(vimagr[i+1]), vimagr[i]);
}

void creaImagenAmpliadaConMargen (timagf *nimaga, tvent vent,
                                  int amph, int ampv,
                                  int marg, int grMarg )
{
  timagf imaga, imag;
  int txa, tya, xa, ya, tam;
  int txa0, tya0;
  int x, y;
  char ** pix, ** pixa;
/**/
  imag  = vent->imaBase;
  imaga = imagfalloc ();
  txa0      = vent->tx * amph ;
  tya0      = vent->ty * ampv ;
  imaga->tx      = txa0 + 2 * marg ;
  imaga->ty      = tya0 + 2 * marg ;
  txa = imaga->tx ;
  tya = imaga->ty ;
  tam = txa * tya ;
  imaga->apixels = (char *) malloc (tam * sizeof(char)) ;
  imaga->ncom    = imag->ncom ;
  imaga->comen   = imag->comen ;
  imaga->niv     = 0 ;
  imaga->base    = imaga ;
  imaga->nf      = imag->nf ;
  imaga->ven0    = ventBaseDeImagf (imaga);
  imaga->venOrig = vent;
  /**/
  pixa = imaga->ven0->pix ;
  pix  = vent->pix ;
  for (ya=0; ya<tya0; ya++)
  for (xa=0; xa<txa0; xa++) {
    x = xa / amph ;
    y = ya / ampv ;
    pixa[ya+marg][xa+marg] = pix[y][x] & 0x0FF ;
    }
  if (marg > 0) {
    /* Norte , todo */
    for (ya=0; ya<marg; ya++)
    for (xa=0; xa<txa ; xa++)
      pixa[ya][xa] = grMarg ;
    /* Sur , todo */
    for (ya=0; ya<marg; ya++)
    for (xa=0; xa<txa ; xa++)
      pixa[ya+tya0+marg][xa] = grMarg ;
    /* Oeste , lateral */
    for (xa=0; xa<marg; xa++)
    for (ya=0; ya<tya0; ya++)
      pixa[ya+marg][xa] = grMarg ;
    /* Este , lateral */
    for (xa=0; xa<marg; xa++)
    for (ya=0; ya<tya0; ya++)
      pixa[ya+marg][xa+txa0+marg] = grMarg ;
    }
  *nimaga = imaga;
}

void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv)
{
  creaImagenAmpliadaConMargen (nimaga, vent, amph, ampv, 0, 0);
}

/*
void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv)
{
  timagf imaga, imag;
  int txa, tya, xa, ya, tam;
  int x, y;
  char ** pix, ** pixa;
  / ** /
  imag  = vent->imaBase;
  imaga = imagfalloc ();
  imaga->tx      = vent->tx * amph ;
  imaga->ty      = vent->ty * ampv ;
  txa = imaga->tx ;
  tya = imaga->ty ;
  tam = txa * tya ;
  imaga->apixels = (char *) malloc (tam * sizeof(char)) ;
  imaga->ncom    = imag->ncom ;
  imaga->comen   = imag->comen ;
  imaga->niv     = 0 ;
  imaga->base    = imaga ;
  imaga->nf      = imag->nf ;
  imaga->ven0    = ventBaseDeImagf (imaga);
  / ** /
  pixa = imaga->ven0->pix ;
  pix  = vent->pix ;
  for (ya=0; ya<tya; ya++)
  for (xa=0; xa<txa; xa++) {
    x = xa / amph ;
    y = ya / ampv ;
    pixa[ya][xa] = pix[y][x] & 0x0FF ;
    }
  *nimaga = imaga;
}
*/

void copiaImagenDeVentana (timagf *nimag, tvent vent)
{
  creaImagenAmpliada (nimag, vent, 1, 1);
}

void creaImagenGrisdeVentanaCapas1 (timagf *nimag, tvent vent, int *pesos)
{
  timagf imagg, imag;
  int sum, sumpesos, sumpesosdiv2;
  int tx, ty, x, y, tam;
  int ncap, ca;
  char ** pix, ** pixg;
  //
  if (vent->imaBase->ncap == 1) {
    copiaImagenDeVentana (nimag, vent);
    return ;
    }
  imag  = vent->imaBase;
  imagg = imagfalloc ();
  tx    = vent->tx;
  ty    = vent->ty;
  imagg->tx      = tx ;
  imagg->ty      = ty ;
  ncap  = imag -> ncap;
  imagg->ncap    = 1;
  tam            = tx * ty ;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imag->ncom ;
  imagg->comen   = imag->comen ;
  imagg->niv     = 0 ;
  imagg->base    = imagg ;
  imagg->nf      = imag->nf ;
  imagg->ven0    = ventBaseDeImagf (imagg);
  //
  sumpesos=0;
  for(ca=0; ca<ncap; ca++)
    sumpesos += pesos[ca];
  sumpesosdiv2 = sumpesos / 2;
  pixg = imagg->ven0->pix ;
  pix  = vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    sum = sumpesosdiv2 ;   // = 0 y final + sumpesosdiv2 => redondeo
    for(ca=0; ca<ncap; ca++)
      sum += (pix[y][x*ncap+ca] & 0x0FF) * pesos[ca];
    pixg[y][x] = sum / sumpesos  ;
    }
  *nimag = imagg;
}

void destruyeVentana (tvent vent)
{
  liberaNodosYlista(vent->lvint);
  free (vent->pix);
  free (vent);
}

void destruyeImagen (timagf imag)
{
  destruyeVentana (imag->ven0);
  free (imag->apixels);
  free (imag); 
}

// -------------------- giros y espejos --------------------

void imagenBase1copiadeVentana (timagf *nimagg, tvent vent, int tx, int ty)
{
  timagf imagg;
  timagf imagb;
  int tam, ncap;
  imagb = vent->imaBase ;
  ncap  = imagb->ncap;
  imagg = imagfalloc ();
  imagg->tx      = tx;
  imagg->ty      = ty;
  tam = tx * ty * ncap;
  imagg->ncap    = imagb->ncap ;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  *nimagg = imagg;
}

void imagenGiradaCDerecha (timagf *nimagg, tvent vent)
{
  timagf imagg;
  int tx, ty, x, y, tyr1, ncap, nc;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  ncap  = vent->imaBase->ncap;
  imagenBase1copiadeVentana (& imagg, vent, ty, tx);
  tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  if (ncap == 1)
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
      pixg[x][tyr1-y] = pix[y][x] & 0x0FF ;
  else
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
    for (nc=0; nc<ncap; nc++)
      pixg[x][(tyr1-y)*ncap+nc] = pix[y][x*ncap+nc] & 0x0FF ;
  *nimagg = imagg;
}

void imagenGiradaCIzquierda (timagf *nimagg, tvent vent)
{
  timagf imagg;
  int tx, ty, x, y, txr1, ncap, nc;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  ncap  = vent->imaBase->ncap;
  imagenBase1copiadeVentana (& imagg, vent, ty, tx);
  txr1 = tx - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  if (ncap == 1)
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
      pixg[txr1-x][y] = pix[y][x] & 0x0FF ;
  else
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
    for (nc=0; nc<ncap; nc++)
      pixg[txr1-x][y*ncap+nc] = pix[y][x*ncap+nc] & 0x0FF ;
  *nimagg = imagg;
}

void imagenGiradaMVuelta (timagf *nimagg, tvent vent)
{
  timagf imagg;
  int tx, ty, x, y, txr1, tyr1, ncap, nc;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  ncap  = vent->imaBase->ncap;
  imagenBase1copiadeVentana (& imagg, vent, tx, ty);
  txr1 = tx - 1;
  tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  if (ncap == 1)
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
      pixg[tyr1-y][txr1-x] = pix[y][x] & 0x0FF ;
  else
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
    for (nc=0; nc<ncap; nc++)
      pixg[tyr1-y][(txr1-x)*ncap+nc] = pix[y][x*ncap+nc] & 0x0FF ;
  *nimagg = imagg;
}

void imagenEspejoV (timagf *nimagg, tvent vent)
{
  timagf imagg;
  // int tx, ty, x, y, txr1, tyr1, ncap, nc;
  int tx, ty, x, y, txr1, ncap, nc;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  ncap  = vent->imaBase->ncap;
  imagenBase1copiadeVentana (& imagg, vent, tx, ty);
  txr1 = tx - 1;
  // tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  if (ncap == 1)
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
      pixg[y][txr1-x] = pix[y][x] & 0x0FF ;
  else
    for (y=0; y<ty; y++)
    for (x=0; x<tx; x++)
    for (nc=0; nc<ncap; nc++)
      pixg[y][(txr1-x)*ncap+nc] = pix[y][x*ncap+nc] & 0x0FF ;
  *nimagg = imagg;
}

// -------------------- reajusta ventana --------------------

void reajustaPix (tvent vent)
{
  char ** pix, ** pixi;
  int y, ty, dx, dy;
  ty   = vent->ty ;
  dy   = vent->dy ;
  dx   = vent->dx ;
  pix  = vent->imaBase->ven0->pix;
  pixi = (char **) malloc (ty * sizeof(char *));
  for (y=0; y<ty; y++)
    pixi[y] = & (pix[y+dy][dx]) ;
  free (vent->pix) ;
  vent->pix = pixi ;
}

void ventanaCreceporelNorte (tvent vent, int dely)
{
  if ((vent->dy < dely) ||
      ((vent->ty - dely) <= 0) ){
    printf ("ocre: error en imag.ventanaCreceporelNorte, fuera de limite\n");
    exit (2);
    }
  vent->dy -= dely ;
  vent->ty += dely ;
  reajustaPix (vent);
}

void ventanaCreceporelSur (tvent vent, int dely)
{
  if (((vent->dy + vent->ty + dely) > vent->imaBase->ty) ||
      ((vent->ty - dely) <= 0) ){
    printf ("ocre: error en imag.ventanaCreceporelSur, fuera de limite\n");
    // exit (2);
    }
  else {
    vent->ty += dely ;
    reajustaPix (vent);
    }
}

/* ---------- ventana en/de ventana ... ---------- */

/* La ventana construida SI DEBE estar dentro de la ventana de partida */
void ventanaEnVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty)
{
  tvent venti;
  char ** pix, ** pixi;
  int y;
  if ((dx < 0)||(dy < 0)||
      (dx+vent->dx+tx > vent->imaBase->tx)||
      (dy+vent->dy+ty > vent->imaBase->ty)  ) {
    printf ("ocre: error en imag.ventanaEnVentana, fuera de limite\n");
    printf (" --                    vent->imaBase->tx:%4d ....->ty:%4d\n",
                            vent->imaBase->tx, vent->imaBase->ty);
    printf (" -- vent->dx:%4d vent->dy:%4d vent->tx:%4d vent->ty:%4d\n",
                 vent->dx,    vent->dy,    vent->tx,    vent->ty);
    printf (" -- int   dx:%4d       dy:%4d       tx:%4d       ty:%4d\n",
                       dx,          dy,          tx,          ty);
    printf ("   ");
    if (dx < 0)
      printf ("Oeste %5d, ", dx);
    if (dy < 0)
      printf ("Norte %5d, ", dy);
    if (dx+vent->dx+tx > vent->imaBase->tx)
      printf ("Este  %5d, ", vent->imaBase->tx - (dx+vent->dx+tx));
    if (dy+vent->dy+ty > vent->imaBase->ty)
      printf ("Sur   %5d, ", vent->imaBase->ty - (dy+vent->dy+ty));
    printf ("\n");
    vent = (tvent)0L; printf (" %4d \n", vent->dx);
    exit (2);
    }
  if ((tx < 0)||(ty < 0)) {
    printf ("ocre: error en imag.ventanaEnVentana, tamanyo negativo: %d,%d\n", tx, ty);
    printf (" -- vent->dx:%4d vent->dy:%4d vent->tx:%4d vent->ty:%4d\n",
                 vent->dx,    vent->dy,    vent->tx,    vent->ty);
    printf (" -- int   dx:%4d       dy:%4d       tx:%4d       ty:%4d\n",
                       dx,          dy,          tx,          ty);
    printf ("   ");
    // pix = 0L;                       //
    // printf ("%5s\n", pix[1000]);    //
    exit (2);
    }
  venti = ventalloc ();  
  venti->tx         = tx ;
  venti->ty         = ty ;
  venti->dx         = vent->dx + dx ;
  venti->dy         = vent->dy + dy ;
 // borrar jue dic 11 18:33:03 CET 2008     +30 dias
  // venti->listaVint  = (tvvents) 0L;
  // venti->glifoDeVen = (tglifo) 0L;
  venti->abstract   = 0L;
  venti->carHisGr   = (struct tcaracHistoGr *) 0L;
  venti->conv       = (int *) 0L;
  venti->ktam       = -1;
  venti->venlimpia  = (tvent) 0L;
  venti->incl       = 0;
  /**/
  venti->pix     = (char **) malloc (ty * sizeof(char *));
  pix = vent->pix ;
  pixi = venti->pix ;
  for (y=0; y<ty; y++)
/*
    pixi[y] = pix[y+dy] + dx*sizeof(char) ;
*/
    pixi[y] = & (pix[y+dy][dx]) ;
  /**/
  venti->imaBase = vent->imaBase ;
  venti->venBase = vent ;
  *nventi = venti ;
}

// cambia dx, dy, (tx, ty)   para que  venti  quepa en  vent
// intenta que el tamaño sea igual, desplaza la nueva ventana
void ventanaEnVentanaCabeIgl (tvent * nventi, tvent vent,
                             int dx, int dy, int tx, int ty)
{
  if (tx > vent->imaBase->tx)
    tx = vent->imaBase->tx ;
  if (dx < 0)
    dx = 0;
  if (dx+vent->dx+tx > vent->imaBase->tx)
    dx = vent->imaBase->tx - (vent->dx + tx) ;
  if (ty > vent->imaBase->ty)
    ty = vent->imaBase->ty ;
  if (dy < 0)
    dy = 0;
  if (dy+vent->dy+ty > vent->imaBase->ty)
    dy = vent->imaBase->ty - (vent->dy + ty) ;
  ventanaEnVentana (nventi, vent, dx, dy, tx, ty);
}

// cambia dx, dy, (tx, ty)   para que  venti  quepa en  vent
// la ventana nueva es la interseccion de la vent. pedida y la vent. base
void ventanaEnVentanaCabeMen (tvent * nventi, tvent vent,
                             int dx, int dy, int tx, int ty)
{
  if (tx > vent->imaBase->tx)
    tx = vent->imaBase->tx ;
  if (dx < 0) {
    tx += dx;
    dx = 0;
    }
  if (dx+vent->dx+tx > vent->imaBase->tx)
    tx = vent->imaBase->tx - (vent->dx + dx);
//
  if (ty > vent->imaBase->ty)
    ty = vent->imaBase->ty ;
  if (dy < 0) {
    ty += dy;
    dy = 0;
    }
  if (dy+vent->dy+ty > vent->imaBase->ty)
    ty = vent->imaBase->ty - (vent->dy + dy);
  ventanaEnVentana (nventi, vent, dx, dy, tx, ty);
}

void ventanaEnVentanaCentrada (tvent * nventi, tvent vent,
                               int dx, int dy )
{
  ventanaEnVentana (nventi, vent, dx, dy, vent->tx-2*dx,vent->ty-2*dy);
}

/* La ventana construida PUEDE NO estar dentro de la ventana de partida */
void ventanaDeVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty)
{
  ventanaEnVentana (nventi, vent->imaBase->ven0,
                    vent->dx+dx,
                    vent->dy+dy,
                    tx, ty);
}

void ventanaDeVentanaCabeMen (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty)
{
  ventanaEnVentanaCabeMen (nventi, vent->imaBase->ven0,
                           vent->dx+dx,
                           vent->dy+dy,
                           tx, ty);
}

// modificaciones -> tambien en  aclaraOeste
void aclaraNorte (tvent vent, int inclH, int y0, int gr)
{
  int x, y, yul;
  int x00, x11, x0, x1;      // limites: x0..tx-1,  0..x1
  int tx;
  char ** pix; 
  tx = vent->tx ;
  pix  = vent->pix ;
  // printf ("inclH: %4d, y0: %4d\n", inclH, y0);
  if (inclH == 0) {
    for (y=0; y<y0; y++) 
    for (x=0; x<tx;  x++) 
      pix[y][x] = gr ;
    }
  else if (inclH > 0) {
    yul = y0 + inclf_desvx(inclH,tx-1);
    for (y=0; y<=yul; y++) {
      x00 = ( (y-y0)*K64 - K32 ) / inclH;
      x0 = max(0,x00);
      for (x=x0; x<tx; x++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclH < 0
    yul = y0;
    for (y=0; y<=yul; y++) {
      x11 = ( (y-y0)*K64 + K32 ) / inclH;
      x1 = min(x11,tx);
      for (x=0; x<x1; x++)
        pix[y][x] = gr ;
      }
    }
}

// modificaciones -> tambien en  aclaraEste
void aclaraSur   (tvent vent, int inclH, int y1, int gr)
{
  int x, y, ypri;
  int x00, x11, x0, x1;      // limites: x0..tx-1,  0..x1
  int tx, ty;
  char ** pix; 
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  //  printf ("inclH: %4d, y1: %4d\n", inclH, y1);
  //  printf ("tx: %4d, ty: %4d\n", tx, ty);
  if (inclH == 0) {
    for (y=y1+1; y<ty; y++) 
    for (x=0; x<tx;  x++) 
      pix[y][x] = gr ;
    }
  else if (inclH > 0) {
    ypri = y1;
    for (y=ypri; y<ty; y++) {
      x11 = ( (y-y1)*K64 + K32 ) / inclH;
      x1 = min (x11,tx);
      for (x=0; x<x1; x++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclH < 0
    ypri = y1 + inclf_desvx(inclH,tx-1);
    for (y=ypri; y<ty; y++) {
      x00 = ( (y-y1)*K64 + K32 ) / inclH;
      x0 = max(0,x00);
      for (x=x0; x<tx; x++)
        pix[y][x] = gr ;
      }
    }
  //  printf ("ypri: %4d\n", ypri);
}

// COPIA de aclaraNorte   tr xyH  yxV    salvo en  pix[y][x]
void aclaraOeste (tvent vent, int inclV, int x0, int gr)
{
  int x, y, xul;
  int y00, y11, y0, y1;      // limites: y0..ty-1,  0..y1
  int ty;
  char ** pix; 
  ty = vent->ty ;
  pix  = vent->pix ;
  // printf ("inclV: %4d, x0: %4d\n", inclH, x0);
  if (inclV == 0) {
    for (x=0; x<x0; x++) 
    for (y=0; y<ty;  y++) 
      pix[y][x] = gr ;
    }
  else if (inclV > 0) {
    xul = x0 + inclf_desvx(inclV,ty-1);
    for (x=0; x<=xul; x++) {
      y00 = ( (x-x0)*K64 - K32 ) / inclV;
      y0 = max(0,y00);
      for (y=y0; y<ty; y++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclV < 0
    xul = x0;
    for (x=0; x<=xul; x++) {
      y11 = ( (x-x0)*K64 + K32 ) / inclV;
      y1 = min(y11,ty);
      for (y=0; y<y1; y++)
        pix[y][x] = gr ;
      }
    }
}

// COPIA de aclaraSur     tr xyH  yxV    salvo en  pix[y][x]
void aclaraEste  (tvent vent, int inclV, int x1, int gr)
{
  int x, y, xpri;
  int y00, y11, y0, y1;      // limites: x0..tx-1,  0..x1
  int tx, ty;
  char ** pix; 
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  //  printf ("inclV: %4d, x1: %4d\n", inclV, x1);
  //  printf ("tx: %4d, ty: %4d\n", tx, ty);
  if (inclV == 0) {
    for (x=x1+1; x<tx; x++) 
    for (y=0; y<ty;  y++) 
      pix[y][x] = gr ;
    }
  else if (inclV > 0) {
    xpri = x1;
    for (x=xpri; x<tx; x++) {
      y11 = ( (x-x1)*K64 + K32 ) / inclV;
      y1 = min (y11,ty);
      for (y=0; y<y1; y++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclV < 0
    xpri = x1 + inclf_desvx(inclV,ty-1);
    for (x=xpri; x<tx; x++) {
      y00 = ( (x-x1)*K64 + K32 ) / inclV;
      y0 = max(0,y00);
      for (y=y0; y<ty; y++)
        pix[y][x] = gr ;
      }
    }
  //  printf ("xpri: %4d\n", xpri);
}

void ventanaLimpParalogrDeVentana (tvent * nventi, tvent vent,
                              int inclH, int y0, int y1, int inclV, int x0, int x1)
{
  struct tecuadrltr cuad;
  tvent venti;
  timagf imag;
  int fondo;
  int dxr, dyr;   // desplazamiento relativo a la ventana anterior.
  pon_paralogr (inclH, y0, y1, inclV, x0, x1, &cuad);
  // imprime_paralogr (& cuad);
  ventanaDeVentanaCabeMen (&venti, vent, cuad.x0, cuad.y0,
                            cuad.x1 - cuad.x0 + 1, cuad.y1 - cuad.y0 + 1);
  dxr = venti->dx - vent->dx;
  dyr = venti->dy - vent->dy;
  copiaImagenDeVentana (&imag, venti);
  fondo = fondoClaro (vent);
  aclaraNorte (imag->ven0, inclH, y0 + inclf_desvx(inclH,dxr) - dyr, fondo);
  aclaraSur   (imag->ven0, inclH, y1 + inclf_desvx(inclH,dxr) - dyr, fondo);
  aclaraOeste (imag->ven0, inclV, x0 + inclf_desvx(inclV,dyr) - dxr, fondo);
  aclaraEste  (imag->ven0, inclV, x1 + inclf_desvx(inclV,dyr) - dxr, fondo);
  * nventi = imag->ven0;
}

void copiaVentana (tvent * nventi, tvent vent)
{
  ventanaEnVentana (nventi, vent, 0, 0, vent->tx, vent->ty);
}

void copiaVentanaaImagen (timagf imag, tvent vent, int dx, int dy)
{
  char ** pix, ** pixd;
  int tx, ty;
  int x, y;
  tvent ventd;
  if ((dx < 0) || (dy < 0) ||
      (imag->tx < (vent->tx + dx)) ||
      (imag->ty < (vent->ty + dy))) {
    printf ("ocre: error en imag.copiaVentanaaImagen, fuera de limite\n");
    printf (" -- imag->tx:%4d imag->ty:%4d vent->tx:%4d vent->ty:%4d\n",
                 imag->tx,    imag->ty,    vent->tx,    vent->ty);
    printf (" --       dx:%4d       dy:%4d\n",
                       dx,          dy);
    vent = (tvent)0L; printf (" %4d \n", vent->dx);
    exit (2);
    }
  ventanaEnVentana (&ventd, imag->ven0, dx, dy, vent->tx, vent->ty);
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pixd = ventd->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++){
    pixd[y][x] =  (pix[y][x] & 0x0FF) ;
    }
}

void ventanaEnVentanaLargHor (tvent * nventi, tvent vent, int dy, int ty)
{
  ventanaEnVentana (nventi, vent, 0, dy, vent->tx, ty);
}

void ventanaEnVentanaLargVer (tvent * nventi, tvent vent, int dx, int tx)
{
  ventanaEnVentana (nventi, vent, dx, 0, tx, vent->ty);
}

void ventanaEnVentanaLargVerInclLimpConMargen_p (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs, int mrg)
{
  tvent vent1;
//  tdcaracHistoGr carHisGr;
  int fondo;
  if (inclvabs > 0) {
    ventanaEnVentanaLargVer (&vent1, vent, dxb, min(txb+inclvabs,vent->tx-dxb));
//    vent1->tx   = min(txb, vent->tx - dxb - inclvabs);
    }
  else {
    ventanaEnVentanaLargVer (&vent1, vent, max(dxb+inclvabs,0), txb + inclvabs);
//    vent1->tx   =  vent->tx - min (0, dxb + inclvabs) ;
    }
//  vent1->incl = (inclvabs * 256 + 128) / vent->ty ;
  vent1->incl = (inclvabs * 256 * 256) / vent->ty ;
/*
  carHisGr = carhisgrDeVentana (vent);
  fondo = carHisGr->xblanco ;
  fondo = 192;
  fondo = fondoClaroFijo (vent);
*/
  fondo = fondoClaro (vent);
  ventanaLimpConMargenDeVentanaIncl (nventi, vent1, fondo, mrg);
}

void ventanaEnVentanaLargVerInclLimpConMargen (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs)
{
  ventanaEnVentanaLargVerInclLimpConMargen_p (nventi, vent, dxb, txb, inclvabs, 5);
}

void ventanaEnVentanaLargVerInclLimpConMargen0 (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs)
{
  ventanaEnVentanaLargVerInclLimpConMargen_p (nventi, vent, dxb, txb, inclvabs, 0);
}

void ventanaAmpliaVentana (tvent * nventi, tvent vent,
                               int marg )
{
  int dx, dy, fx, fy, tx, ty;
  tvent vB ;
  vB = vent->imaBase->ven0;
  dx = max(0, vent->dx - marg);
  dy = max(0, vent->dy - marg);
  fx = min(vB->tx-1, vent->dx+vent->tx-1+marg);
  fy = min(vB->ty-1, vent->dy+vent->ty-1+marg);
  tx = fx-dx+1;
  ty = fy-dy+1;
  ventanaEnVentana (nventi, vB, dx, dy, tx, ty);
  (*nventi)->venBase = vent->venBase;
}

tvvents vventsalloc (int n)
{
  tvvents vvents;
  vvents = (tvvents) malloc (sizeof(struct tevvents)); 
  vvents->n = n;
  vvents->ventanas = (tvent *) malloc(n * sizeof(tvent));
  return vvents ;
}

void vventsfree (tvvents vvents)
{
  free (vvents->ventanas);
  free (vvents) ; 
}

void desplazaBase (int nivr)
{
  printf ("%*s", nivr*3, "");
}

void describeVentana0 (tvent vent, int nivr, int desp)
{
  Boolean lista1;
  desplazaBase (nivr+desp);
  printf ("ventana, nid:%d-%d,",
           vent->nid, vent->imaBase->nid);
  printf ("tamanyo:%dx%d, desplazamiento: %4d,%4d inclinacion: %4d\n",
           vent->tx, vent->ty, vent->dx, vent->dy, vent->incl);
  lista1 = FALSE;
  if (vent->venlimpia == 0L) {
    desplazaBase (nivr+desp);
    printf ("ventana limpia");
    lista1 = TRUE;
    }
  if (tomaValordeListaAtributos (vent->atributs, "capitular") != 0L) {
    if (! lista1) {
      desplazaBase (nivr+desp);
      printf ("ventana");
      }
      lista1 = TRUE;
      printf (" capitular");
    }
  if (lista1)
    printf ("\n");
//
  if (vent->imaBase->venOrig != 0){
    desplazaBase (nivr+desp);
    printf ("base:\n");
    describeVentana0 (vent->imaBase->venOrig, nivr+1, desp);
    }
  if (listaVacia(vent->lvint)) {
    desplazaBase (nivr+desp);
    printf ("ventana sin subventanas\n");
    }
  else {
    desplazaBase (nivr+desp);
    printf ("ventana con subventanas: %3d\n", longLista (vent->lvint));
    }
//  if (vent->abstract   != 0L)
//    printf ("vent.   contenido: %s\n", vent->glifoDeVen->letras);
//    printf ("vent.   contenido: %s\n", vent->abstract->letras);
}

void describeVentana (tvent vent)
{
  describeVentana0 (vent, 0, 0);
}

void describeVentanaPgen (tpgen vent)
{
  describeVentana0 ((tvent) vent, 0, 1);
}

void describeVentanas (tvent vent, int niv)
{
  describeVentana (vent);
  recorreListaAplicando (vent->lvint, describeVentanaPgen);
}

void describeVventanas (tvvents vvents)
{
  int i;
  printf ("vector ventanas, numero: %4d\n", vvents->n);
  for (i=0; i < vvents->n; i++) {
    printf ("%03d", i);
    describeVentana (vvents->ventanas[i]);
    }
}

void desplazamientosBase (int *dx, int *dy, int* tx, int *ty, tvent vent)
{
  int dxl, dyl, dxb, dyb;
  dxl = vent->dx;
  dyl = vent->dy;
  if (vent->imaBase->venOrig != 0) {
    desplazamientosBase (&dxb, &dyb, tx, ty, vent->imaBase->venOrig);
    dxl += dxb;
    dyl += dyb;
    }
  else {
    *tx = vent->venBase->tx;
    *ty = vent->venBase->ty;
    }
  *dx = dxl;
  *dy = dyl;
}

void desplazamientosBase2 (int *dx, int *dy, tvent vent)
{
  int dxl, dyl, dxb, dyb;
  dxl = vent->dx;
  dyl = vent->dy;
  if (vent->imaBase->venOrig != 0) {
    desplazamientosBase2 (&dxb, &dyb, vent->imaBase->venOrig);
    // anulo por error en escribeVentanadeGlifoCar,  mié abr 12 11h 2017
    // dxl += dxb - 5;
    // dyl += dyb - 5;
    }
  *dx = dxl;
  *dy = dyl;
}

/*
void ponerCarhisgrenVentana (tvent vent, tdcaracHistoGr carHisGr)
{
  vent->carHisGr = (tdcaracHistoGr) malloc (sizeof(struct tcaracHistoGr));
  vent->carHisGr->xblanco  = carHisGr->xblanco ;
  vent->carHisGr->xnegro   = carHisGr->xnegro  ;
  vent->carHisGr->alturaB  = carHisGr->alturaB  ;
  vent->carHisGr->alturaN  = carHisGr->alturaN  ;
  vent->carHisGr->ppmB     = carHisGr->ppmB  ;
  vent->carHisGr->ppmN     = carHisGr->ppmN  ;
  vent->carHisGr->desvB    = carHisGr->desvB  ;
  vent->carHisGr->desvN    = carHisGr->desvN  ;
}
*/

void ponerConvenVentana (tvent vent, int *conv)
{
  int i;
  vent->conv = (int *) malloc (256 * sizeof(int));
  for (i=0; i<=255; i++)
    vent->conv[i] = conv[i];
}

/*
int * tenerConvSobreVentana (tvent vent)
{
  tvent v;
  for (v=vent; v->conv == 0L; v=v->venBase)
    if (v == v->venBase)
      v = v->imaBase->venOrig ;
  return v->conv ;
}

int * tenerConvSobreVentana (tvent vent)
{
  tvent v;
  for (v=vent; v->conv == 0L; v=v->venBase)
    if ((v->conv == 0L) && (v == v->venBase))
      v = v->imaBase->venOrig ;
  return v->conv ;
}
*/

// sáb mar 12 19:26:44 CET 2011
int * tenerConvSobreVentana (tvent vent)
{
  tvent v;
  for (v=vent; v->conv == 0L; )
    if ((v->conv == 0L) && (v == v->venBase))
      v = v->imaBase->venOrig ;
    else
      v = v->venBase ;
  return v->conv ;
}

/*

tdcaracHistoGr carhisgrDeVentana (tvent vent)
{
  tdcaracHistoGr carHgr;
  tvent v;
  v = vent;
  while (v->carHisGr == 0L) {
    // if (v->venBase == 0L) {
    if (v->venBase == v) {
      carHgr = carhisgrDeVentanaCalculado (v);
      ponerCarhisgrenVentana (v, carHgr);
      return carHgr ;
//      printf ("ocre: error en imag.carhisgrDeVentana, no encontrado carHisGr\n");
//      exit (2);
      }
    v = v->venBase ;
    }
  return v->carHisGr ;
}

*/

int ktamDeVentana (tvent vent)
{
  tvent v;
  v = vent;
  while (v->ktam == -1) {
/*
    if (v->venBase == 0L) {
*/
    if (v->venBase == v) {
      break ;
      }
    v = v->venBase ;
    }
  if (d_valori >= 10)
    printf ("ocre: imag.ktamDeVentana, ktam=%4d\n", v->ktam);
  return v->ktam ;
}

int valorintEncomImagen (char * nvariable, timagf imagf)
{
  int val;
  int n, i;
  char * donde;
  n = imagf->ncom;
  val = -1;
  for (i=0; i<n; i++) {
    donde = strstr (imagf->comen[i], nvariable);
    if (donde != NULL) {
      sscanf (donde, "%*s %d", &val);
      break;
      }
    }
  return val ;
}

Boolean mismaBaseVentanas (tvent vent1, tvent vent2)
{
  return vent1->imaBase == vent2->imaBase;
}

void unionGventanas (tvent * nvent, tvent vent1, tvent vent2)
{
  int dx1, dx2, dx;
  int dy1, dy2, dy;
  int fx1, fx2, fx;
  int fy1, fy2, fy;
  /* si las imagenes base son distintas: excepcion */
  if (vent1->imaBase != vent2->imaBase) {
    printf ("ocre: error en imag.unionGventanas, vent1 y vent2 tienen distinata base\n");
    exit(2);
    }
  dx1 = vent1->dx;
  dy1 = vent1->dy;
  fx1 = dx1 + vent1->tx - 1;
  fy1 = dy1 + vent1->ty - 1;
  dx2 = vent2->dx;
  dy2 = vent2->dy;
  fx2 = dx2 + vent2->tx - 1;
  fy2 = dy2 + vent2->ty - 1;
  dx  = min (dx1, dx2);
  dy  = min (dy1, dy2);
  fx  = max (fx1, fx2);
  fy  = max (fy1, fy2);
  ventanaEnVentana (nvent, vent1->imaBase->ven0, dx, dy, fx-dx+1, fy-dy+1);
}

void intervaloCentrado (int *dxi, int *dxf, int tg, int tm, int tp, int dxp, int escala )
{
  int xi, xf, cdgv;
  if ( (tg - 1) <= ((tm -1)/escala) ) {
    xi = 0;
    xf = tg - 1;
    }
  else {
    cdgv = dxp + tp / 2;
    xi = cdgv - (tm / (escala * 2)) ;
    xf = xi + (tm - 1) / escala ;
    if ( xi < 0 ) {
      xi = 0;
      xf = (tm - 1) / escala ;
      }
    else if (xf > (tg - 1) ) {
      xf = tg -1 ;
      xi = xf - (tm - 1) / escala ;
      }
    }
  *dxi = xi;
  *dxf = xf;
}

void ventanaAlrededor (tvent *nvent, tvent vent, int tx, int ty, int escala) 
{
  int xi, xf, yi, yf;
  tvent v0;
  v0 = vent->imaBase->ven0;
  intervaloCentrado (&xi, &xf, v0->tx, tx, vent->tx, vent->dx, escala );
  intervaloCentrado (&yi, &yf, v0->ty, ty, vent->ty, vent->dy, escala );
  ventanaEnVentana (nvent, v0, xi, yi, xf-xi+1, yf-yi+1);
}

void ventanaVertDeVentanaIncl (tvent * nventi, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int incl, desx;
  int tx, ty, x, y, tam;
  char ** pix, ** pixg;
  int xp;
  int dxs;
  incl   = vent->incl;
  ty    = vent->ty;
  dxs = inclf_desvx(incl, ty-1);
  tx    = vent->tx - abs(dxs);
  tx    = max(tx,1);      // para evitar tx == 0; 20091012
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = tx;
  imagg->ty      = ty;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;   
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  xp = (incl > 0) ? 0 : - dxs ;
  for (y=0; y<ty; y++){
    desx = xp + inclf_desvx(incl, y);
    for (x=0; x<tx; x++) 
      pixg[y][x] = pix[y][x+desx] & 0x0FF ;
    }
  *nventi = imagg->ven0 ;
}

void ventanaLimpConMargenDeVentanaIncl (tvent * nventi, tvent vent, int fondo,
                                        int marg)
{
  int incl, desx;
  int tx, ty, x, y;
  char ** pix;
  int xp, xu;
  timagf  nimag;
  incl   = vent->incl;
  tx     = vent->tx;
  ty     = vent->ty;
  creaImagenAmpliadaConMargen (&nimag, vent, 1, 1, marg, fondo);
  ventanaEnVentana (nventi, nimag->ven0, marg, marg, tx, ty);
  pix  = (*nventi)->pix ;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  // pon fondo en triangulos
  for (y=0; y<ty; y++){
    desx = inclf_desvx(incl, y);
    for (x=0; x<tx; x++) {
      if (x < (xp + desx))
        pix [y][x] = fondo ;
      if (x > (xu + desx))
        pix [y][x] = fondo ;
      }
    }
}

// la base de ampliacion va a ser vent1, incognita,
//              y se tanteara con vent2, pruebas.
void ventanaLimpConMargenPara2vents (tvent * nventi, tvent vent1, tvent vent2,
		                     int delta2resp1, int fondo, int marg)
{
  int margen2y, margen2x, margen2;
  int sobresaleNorte, sobresaleSur;
  sobresaleNorte = max(0, -delta2resp1);
  sobresaleSur   = max(0, vent2->ty - vent1->ty + delta2resp1);
  margen2y = max(0, sobresaleNorte + sobresaleSur) + marg;
  margen2x = max(0, vent2->tx - vent1->tx) / 2 + 1 + marg;
  margen2  = max(margen2x, margen2y);
  ventanaLimpConMargenDeVentanaIncl (nventi, vent1, fondo, margen2);
}

void ventanaLimpDeVentanaIncl (tvent * nventi, tvent vent, int fondo)
{
  ventanaLimpConMargenDeVentanaIncl (nventi, vent, fondo, 0);
}

/*
// lo borrare ?, o tengo que cambiar la inclinacion 
// inclinacion _tz 
void ventanaLimpDeVentanaIncl2 (tvent * nventi, tvent vent, int fondo)
{
  int inc, desx;
  int tx, ty, x, y;
  char ** pix;
  int xp, xu, imas1;
  timagf  nimag;
  copiaImagenDeVentana (&nimag, vent);
  inc   = vent->incl;
  tx    = vent->tx;
  ty    = vent->ty;
  pix  = nimag->ven0->pix ;
  // pon_cp_cu_imas1 (inc, vent->tx, &xp, &xu, &imas1) ;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  for (y=0; y<ty; y++){
    // desx = (y * imas1) / ty ;
    desx = inclf_desvx(incl, y);
    for (x=0; x<tx; x++) {
      if (x < (xp + desx))
        pix [y][x] = fondo ;
      if (x > (xu + desx))
        pix [y][x] = fondo ;
      }
    }
  *nventi = nimag->ven0 ;
}
*/

// desplazamientos para
// (ventana) contexto   de una ventana  vent,  cuya base es venBase
void desp_contexto (int *dcx, int *dcy, tvent venBase, tvent vent, int tcx, int tcy)
{
  int tcrtvd2x, tcrtvd2y;     // tamanyo contexto resta ... ventana divide por dos
  tcrtvd2x = (tcx - vent->tx) / 2;
  if (vent->dx < tcrtvd2x)
    *dcx = 0;
  else if (vent->dx > (venBase->tx - tcrtvd2x - vent->tx))
    *dcx = venBase->tx - tcx;
  else
    *dcx = vent->dx - tcrtvd2x;
  //
  tcrtvd2y = (tcy - vent->ty) / 2;
  if (vent->dy < tcrtvd2y)
    *dcy = 0;
  else if (vent->dy > (venBase->ty - tcrtvd2y - vent->ty))
    *dcy = venBase->ty - tcy;
  else
    *dcy = vent->dy - tcrtvd2y;
}


void imprimeConv (int * conv)
{
 int i;
 printf ("ocre.imag.imprimeConv\n");
 for (i=0; i<=255; i++) {
   printf (" %3d",conv[i]);
   if ((i%20)==19)
     printf ("\n");
   }
 printf ("\n");
}

void cdgVentana (int *cdgx, int *cdgy, tvent vent, int ampl)
{
 int * conv;
 int x, y, tx, ty;
 char ** pix;
 int sumpix, sumxpix, sumypix;
 int sumpixPoramplEntredos;
 int pixconv;
 // conv = vent->conv;
 conv = tenerConvSobreVentana (vent); 
 // imprimeConv (conv);
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 sumpix  = 0;
 sumxpix = 0;
 sumypix = 0;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   pixconv = 255 - conv[(pix[y][x] & 0xFF)];
   sumpix  += pixconv ;
   sumxpix += pixconv * x ;
   sumypix += pixconv * y ;
   if (d_valori >= 50)
     printf ("x=%4d y=%4d pix[y,x]=%3d, pixconv=%3d sumpix=%7d sumxpix=%9d, sumypix=%9d\n",
              x,    y,    pix[y][x]&0xFF, pixconv,  sumpix,    sumxpix,     sumypix);
   }
 sumpixPoramplEntredos = (sumpix * ampl) / 2;
 * cdgx = (sumxpix * ampl  + sumpixPoramplEntredos ) / sumpix ;
 * cdgy = (sumypix * ampl  + sumpixPoramplEntredos ) / sumpix ;
}

void maximoenVentana (int *mxx, int *mxy, int *mxp, tvent vent)
{
 int x, y, tx, ty;
 char ** pix;
 int opix;
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 *mxx  = 0;
 *mxy  = 0;
 *mxp  = 0;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   opix = (pix[y][x] & 0xFF) ;
   if (opix > *mxp) {
     *mxx  = x;
     *mxy  = y;
     *mxp  = opix;
     }
   }
}

tvent seleccionaSubventana (tvent vent, char *selec)
{
  int lsel;
  tvent v;
  int i, j;
  lsel = strlen (selec);
  if (lsel < 2) {
    printf ("ocre.imag.seleccionaSubventana: error, seleccion corta\n");
    exit (40);
    }
  if (selec[0] != 'c') {
    printf ("ocre.imag.seleccionaSubventana: seleccion no comienza por 'c'\n");
    exit (40);
    }
  i = lsel - 1;
  if (selec[i] != 'r') {
    printf ("ocre.imag.seleccionaSubventana: seleccion no acaba en 'r'\n");
    exit (40);
    }
  i -- ;
  v = vent;
  while (i>0) {
    j = 1;
    while (selec[i]=='d'){
      i--; j++;
      }
    if (selec[i] != 'a') {
      printf ("ocre.imag.seleccionaSubventana: seleccion le falta una 'a'\n");
      exit (40);
      }
    if (listaVacia(v->lvint)) {
      printf ("ocre.imag.seleccionaSubventana:  no hay subventanas\n");
      exit (40);
      }
    if (longLista(v->lvint) < j) {
      printf ("ocre.imag.seleccionaSubventana:  no hay %3d tantas subventanas\n", j);
      exit (40);
      }
    v = (tvent) (enesimoNodoDeLista (v->lvint, j) ->aitem);
    i--;
    }
  return v;
}

/* ------ misc ---------- */

Boolean ventanaMenor(tvent v1, tvent v2)
// v1  menor que  v2
{
  return ((v1->tx < v2->tx) && (v1->ty <= v2->ty)) ||
         ((v1->ty < v2->ty) && (v1->tx <= v2->tx)) ;
}

Boolean ventanaAlsur(tvent v1, tvent v2)
// v1  al sur de  v2  , algo de v1 bajo v2
{
  return ( ((v1->dx + v1->tx) > v2->dx) &&
           ((v2->dx + v2->tx) > v1->dx)  ) &&
	 ( (v1->dy + v1->ty) > (v2->dy + v2->ty) ) ;
}

Boolean ventanaDentro (tvent v1, tvent v2)
// v1  dentro de o igual v2
{
  return ((v1->dx >= v2->dx) && (v1->dx+v1->tx <= v2->dx+v2->tx)) &&
         ((v1->dy >= v2->dy) && (v1->dy+v1->ty <= v2->dy+v2->ty)) ;
}

// ------ a borrar cuando no haya 'tvvent' ----------
//         y vaya todo con listas

tvvents vventDeLista (lista l)
{
  tvvents vvents;
  tnodol nodol;
  int n, i;
  n = longLista (l);
  vvents = vventsalloc (n);
  nodol = l->primero;
  for (i=0; i<n; i++) {
    vvents->ventanas[i] = nodol->aitem;
    nodol = nodol->siguiente;
    }
  return vvents ;
}

void umbralizaVentana (tvent vent, int gr)
{
 int x, y, tx, ty;
 char ** pix;
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   if ((pix[y][x] & 0xFF) > gr)
     pix[y][x] = 255;
   else
     pix[y][x] = 0;
   }
}

// -------------------- erosion discreta -------------------- 

void erosionada1VentanaDeVentana (tvent vente, tvent vent,
                                  int grum, int grbl)
{
 int x, y, tx, ty;
 int xe, ye, xe0, ye0, xe1, ye1;
 char ** pix;
 char ** pixe;
 pix   = vent->pix;
 pixe  = vente->pix;
 tx    = vent->tx;
 ty    = vent->ty;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   if ((pix[y][x] & 0xFF) > grum) {
     ye0 = max(0,y-1) ;
     ye1 = min(ty,y+1) ;
     xe0 = max(0,x-1) ;
     xe1 = min(tx,x+1) ;
     for (ye=ye0; ye<ye1; ye++)
     for (xe=xe0; xe<xe1; xe++) {
       pixe[ye][xe] = grbl;
       }
     }
   }
}

void erosionadaBl1VentanaDeVentana (tvent vente, tvent vent,
                                  int grum, int grng)
{
 int x, y, tx, ty;
 int xe, ye, xe0, ye0, xe1, ye1;
 char ** pix;
 char ** pixe;
 pix   = vent->pix;
 pixe  = vente->pix;
 tx    = vent->tx;
 ty    = vent->ty;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   if ((pix[y][x] & 0xFF) <= grum) {
     ye0 = max(0,y-1) ;
     ye1 = min(ty,y+1) ;
     xe0 = max(0,x-1) ;
     xe1 = min(tx,x+1) ;
     for (ye=ye0; ye<ye1; ye++)
     for (xe=xe0; xe<xe1; xe++) {
       pixe[ye][xe] = grng;
       }
     }
   }
}

// -------------------- erosion continua -------------------- 

void erosionadaCont1VentanaDeVentana (tvent vente, tvent vent)
{
 int x, y, tx, ty;
 int xe, ye, xe0, ye0, xe1, ye1;
 char ** pix;
 char ** pixe;
 int grbl;
 pix   = vent->pix;
 pixe  = vente->pix;
 tx    = vent->tx;
 ty    = vent->ty;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   ye0 = max(0,y-1) ;
   ye1 = min(ty-1,y+1) ;
   xe0 = max(0,x-1) ;
   xe1 = min(tx-1,x+1) ;
   grbl = 0 ;
   for (ye=ye0; ye<=ye1; ye++)
   for (xe=xe0; xe<=xe1; xe++) {
     if ((pix[ye][xe] & 0xFF) > grbl)
        grbl = pix[ye][xe] & 0xFF ;
     // printf ("%3d %3d %3d %3d %3d\n", x, y, xe, ye, grbl);
     }
   pixe[y][x] = grbl ;
   }
}

void erosionadaImagenDeVentana (timagf *image, tvent vent,
                                  int grum, int grbl, int n)
{
 timagf imaga, imagb, imagx;
 int i;
 copiaImagenDeVentana (&imaga, vent);
 erosionada1VentanaDeVentana (imaga->ven0, vent, grum, grbl);
 if (n > 1) {
   copiaImagenDeVentana (&imagb, vent);
   for (i=1; i<n; i++) {
     erosionada1VentanaDeVentana (imagb->ven0, imaga->ven0, grum, grbl);
     // intercambia (punteros)
     imagx = imaga;  imaga = imagb;  imagb = imagx;
     }
     destruyeImagen (imagb);
   }
 *image = imaga;
}

void erosionadaContImagenDeVentana (timagf *image, tvent vent, int n)
{
 timagf imaga, imagb, imagx;
 int i;
 copiaImagenDeVentana (&imaga, vent);
 erosionadaCont1VentanaDeVentana (imaga->ven0, vent);
 if (n > 1) {
   copiaImagenDeVentana (&imagb, vent);
   for (i=1; i<n; i++) {
     erosionadaCont1VentanaDeVentana (imagb->ven0, imaga->ven0);
     // intercambia (punteros)
     imagx = imaga;  imaga = imagb;  imagb = imagx;
     }
     destruyeImagen (imagb);
   }
 *image = imaga;
}

void erosionadaBlImagenDeVentana (timagf *image, tvent vent,
                                  int grum, int grng, int n)
{
 timagf imaga, imagb, imagx;
 int i;
 copiaImagenDeVentana (&imaga, vent);
 erosionadaBl1VentanaDeVentana (imaga->ven0, vent, grum, grng);
 if (n > 1) {
   copiaImagenDeVentana (&imagb, vent);
   for (i=1; i<n; i++) {
     erosionadaBl1VentanaDeVentana (imagb->ven0, imaga->ven0, grum, grng);
     // intercambia (punteros)
     imagx = imaga;  imaga = imagb;  imagb = imagx;
     }
     destruyeImagen (imagb);
   }
 *image = imaga;
}

Boolean llegaGrisV (tvent vent, int y, int gr)
{
  int x, tx;
  Boolean llg;
  char ** pix;
//  if (vent->incl != 0)
//    return llegaGrisIncl (vent, y, gr) ;
  llg = FALSE ;
  tx  = vent->tx;
  pix = vent->pix;
  for (x=0; x<tx; x++)
    if ((pix[y][x] & 0xFF) < gr)
      llg = TRUE ;
  return llg ;
}

void ajustadaV (tvent *nvent, tvent vent, int gr)
{
  int y0, y1, ty;
  ty =  vent->ty;
  y0  = 0;
  // desplaza hacia abajo el limite superior
  while ((y0 < ty) && ! llegaGrisV (vent, y0, gr))
    y0 ++ ;
  y1 = ty - 1;
  // desplaza hacia arriba el limite inferior
  while ((y1 >y0) && ! llegaGrisV (vent, y1, gr))
    y1 -- ;
  ventanaEnVentanaLargHor (nvent, vent, y0, y1-y0+1);
  if (d_valori >= 40)
    printf ("ocre: ajustadaV\n") ;
}

Boolean llegaGrisH (tvent vent, int x, int gr)
{
  int y, ty;
  Boolean llg;
  char ** pix;
//  if (vent->incl != 0)
//    return llegaGrisIncl (vent, y, gr) ;
  llg = FALSE ;
  ty  = vent->ty;
  pix = vent->pix;
  for (y=0; y<ty; y++)
    if ((pix[y][x] & 0xFF) < gr)
      llg = TRUE ;
  return llg ;
}

void ajustadaH (tvent *nvent, tvent vent, int gr)
{
  int x0, x1, tx;
  tx =  vent->tx;
  x0  = 0;
  // desplaza hacia la derecha el limite izquierdo
  while ((x0 < tx) && ! llegaGrisH (vent, x0, gr))
    x0 ++ ;
  x1 = tx - 1;
  // desplaza hacia la izquierda el limite derecho
  while ((x1 >x0) && ! llegaGrisH (vent, x1, gr))
    x1 -- ;
  ventanaEnVentanaLargVer (nvent, vent, x0, x1-x0+1);
  if (d_valori >= 40)
    printf ("ocre: ajustadaH\n") ;
}

void ajustadaVH (tvent *nvent, tvent vent, int gr)
{
  tvent venti;
  ajustadaV (&venti, vent,  gr);
  ajustadaH (nvent,  venti, gr);
  (*nvent)->venBase = vent;
  destruyeVentana (venti);
  if (d_valori >= 40)
    printf ("ocre: ajustadaVH\n") ;
}

// ajusta una ventana extendiendola    // chapuza
void ajustadaVHext (tvent *nvent, tvent vent, tvent ventmx, int gr)
{
  int dx, fx, dy, fy, dxmn, fxmx, dymn, fymx;
  tvent venti, venti2, venti3;
  // describeVentana (vent);
  // describeVentana (ventmx);
  dxmn = ventmx->dx;
  dymn = ventmx->dy;
  fxmx = ventmx->dx + ventmx->tx - 1;
  fymx = ventmx->dy + ventmx->ty - 1;
  copiaVentana (&venti, vent);
  // while ((dx>=dxmn) && (dy>=dymn) && (fx<=fxmx) && (fy<=fymx)) {  // tntria
  do {
    // describeVentana (venti);
    dx = venti->dx;
    dy = venti->dy;
    fx = venti->dx + venti->tx - 1;
    fy = venti->dy + venti->ty - 1;
    dx = max(dxmn, dx-1);
    dy = max(dymn, dy-1);
    fx = min(fxmx, fx+1);
    fy = min(fymx, fy+1);
    ventanaDeVentana (&venti2, venti->imaBase->ven0,
                      dx, dy, fx-dx+1, fy-dy+1);
    ajustadaVH (&venti3, venti2, gr);
    destruyeVentana (venti2);
    if ( (venti3->dx == venti->dx) && (venti3->dy == venti->dy) &&
         (venti3->tx == venti->tx) && (venti3->ty == venti->ty)   )
      break;
    // printf (" %d.%d-%d.%d", dx, dy, fx, fy);
    destruyeVentana (venti);
    copiaVentana (&venti, venti3);
    } while ((dx>dxmn) || (dy>dymn) || (fx<fxmx) || (fy<fymx)) ;
  // printf ("\n");
  *nvent = venti3;
  if (d_valori >= 40)
    printf ("ocre: ajustadaVHext\n") ;
}

// --------------- funciones 1 pix ---------------

void transparencia1 (timagf *nimag, tvent vent, tvent vmasc, int *ft, int gr0)
{
  timagf imagt;
  char ** pix;
  char ** pixm;
  char ** pixf;
  int gr, grm;
  int grf;
  int tx, ty, x, y;
  int ftc[256];
  for (gr=0; gr<256; gr++)
    ftc[gr] = 255 - ft[gr];
  pix  = vent->pix ;
  pixm = vmasc->pix ;
  tx = min(vent->tx, vmasc->tx);
  ty = min(vent->ty, vmasc->ty);
  creaImagenVacia (&imagt, tx, ty);
  pixf  = imagt->ven0->pix ;
  for (y=0; y<ty; y++) 
  for (x=0; x<tx; x++) {
    gr = (pix[y][x] & 0x0FF) ;
    grm = (pixm[y][x] & 0x0FF) ;
    pixf[y][x] = grf = (gr * ft[grm] + (gr0 * ftc[grm]) +127) / 255;
    // printf ("%4d %4d %4d\n", gr, grm, grf);
    }
  *nimag = imagt;
}

void imagenPixMin (timagf *nimag, tvent vent1, tvent vent2)
{
  timagf imagt;
  char ** pix;
  char ** pixm;
  char ** pixf;
  int gr, grm;
  int grf;
  int tx, ty, x, y;
  // int ftc[256];
  // for (gr=0; gr<256; gr++)
  //   ftc[gr] = 255 - ft[gr];
  pix  = vent1->pix ;
  pixm = vent2->pix ;
  tx = min(vent1->tx, vent2->tx);
  ty = min(vent1->ty, vent2->ty);
  creaImagenVacia (&imagt, tx, ty);
  pixf  = imagt->ven0->pix ;
  for (y=0; y<ty; y++) 
  for (x=0; x<tx; x++) {
    gr = (pix[y][x] & 0x0FF) ;
    grm = (pixm[y][x] & 0x0FF) ;
    // pixf[y][x] = grf = (gr, 255-grm)/2 ;
    pixf[y][x] = grf = min(gr, 255-grm)/2 ;   // min?
    // printf ("%4d %4d %4d\n", gr, grm, grf);
    }
  *nimag = imagt;
}

void imagenX1 (timagf *nimag, tvent vent1)
{
  timagf imagt;
  char ** pix;
  // char ** pixm;
  char ** pixf;
  int gr;
  int grf;
  int tx, ty, x, y;
  int xc, yc, ix, iy;
  int grmin, grmax;
  pix  = vent1->pix ;
  tx = vent1->tx ;
  ty = vent1->ty ;
  creaImagenVacia (&imagt, tx, ty);
  pixf  = imagt->ven0->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    grmin = 255;
    grmax = 0;
    for (iy=-1; iy<=1;iy++)
    for (ix=-1; ix<=1;ix++) {
      yc=max(0,y+iy); yc=min(ty-1,yc);
      xc=max(0,x+ix); xc=min(tx-1,xc);
      grmin = min(grmin, (pix[yc][xc] & 0x0FF));
      grmax = max(grmin, (pix[yc][xc] & 0x0FF));
      }
    gr = grmin - (grmax-grmin)/3 ;
    pixf[y][x] = grf = max(0,gr) ;
    // printf ("%4d %4d %4d\n", gr, grm, grf);
    }
  *nimag = imagt;
}

// ---------------  ---------------

Boolean eliminarHijosTapadosTpgen (tpgen ventFam, tpgen ventG)
{
  return eliminarHijosTapados ((tvent) ventFam, (tvent) ventG);
}

Boolean eliminarHijosTapados (tvent ventFam, tvent ventG)
{
  if (ventG == ventFam)
    return FALSE;
  if (! listaVacia (ventFam->lvint))
    eliminaDeListaSiFuncEResul (ventFam->lvint, ventG, eliminarHijosTapadosTpgen, TRUE);
  if (listaVacia (ventFam->lvint))
    return ventanaDentro (ventFam, ventG);
  else
    return FALSE;
}

// ---------------  ---------------

int gaus2d5am [5][5] = { { 2,  4,  5,  4,  2} ,
                         { 4,  9, 12,  9,  4} ,
                         { 5, 12, 15, 12,  5} ,
                         { 4,  9, 12,  9,  4} ,
                         { 2,  4,  5,  4,  2}  };
int gaus2d5adv = 159;
int gaus2d5atx = 5;
int gaus2d5aty = 5;

/**/
void imagenConvolucionDeVentana (timagf *nimag, tvent vent, int ** mat_conv, int txc, int tyc, int divc)
{
  char ** pix;
  char ** pixn;
  timagf imag;
  int tx, ty, x, y, xc, yc;
  int ac;
  pix  = vent->pix ;
  tx = vent->tx ;
  ty = vent->ty ;
  creaImagenVacia (&imag, tx, ty);
  pixn = imag->ven0->pix ;
  // for (y=0; y<ty; y++) 
  // for (x=0; x<tx; x++) {
  for (y=0; y<=(ty-tyc); y++) 
  for (x=0; x<=(tx-txc); x++) {
    ac = 0;
    for (yc=0; yc<tyc; yc++) 
    for (xc=0; xc<txc; xc++) {
      // ac += (pix[y+yc][x+xc] & 0xFF) * mat_conv[yc][xc];
      ac += (pix[y+yc][x+xc] & 0xFF) * gaus2d5am [yc][xc];
      }
    pixn[y][x] = ((ac + divc/2) / divc) & 0xFF;
    } 
  *nimag = imag;
}

/*
int ** gaus2d5am ;

void inim_gaus2d5am ()
{
  int x, y;
  int l [5][5] = { { 2,  4,  5,  4,  2} ,
                   { 4,  9, 12,  9,  4} ,
                   { 5, 12, 15, 12,  5} ,
                   { 4,  9, 12,  9,  4} ,
                   { 2,  4,  5,  4,  2}  };
  gaus2d5am = (int **) malloc (5 * sizeof (int *));
  for (y=0; y<4; y++)
    gaus2d5am [y] = (int *) malloc (5 * sizeof (int));
  for (y=0; y<4; y++)
  for (x=0; x<4; x++)
    gaus2d5am [y][x] = l[y][x];
}
*/
                  
void imagenConvolucionDeVentana_gaus2d5a (timagf *nimag, tvent vent)
{
  // inim_gaus2d5am ();
  imagenConvolucionDeVentana (nimag, vent,
                              (int **) gaus2d5am, gaus2d5atx, gaus2d5aty, gaus2d5adv);
}

/*   tonteria 2016 05 20, Borrar en un mes
int escq2d5am [5][5] = { { 6,  5,  3,  1,  0} ,
                         { 5,  5,  3,  1,  1} ,
                         { 3,  3,  3,  3,  3} ,
                         { 1,  1,  3,  5,  5} ,
                         { 0,  1,  3,  5,  6}  };
int escq2d5adv = 175;
int escq2d5atx = 5;
int escq2d5aty = 5;

void imagenConvolucionDeVentana_escq2d5a (timagf *nimag, tvent vent)
{
  // inim_escq2d5am ();
  imagenConvolucionDeVentana (nimag, vent,
                              escq2d5am, escq2d5atx, escq2d5aty, escq2d5adv);
}
*/

/**/
