
#include <stdio.h>
#include <stdlib.h>

#include "base.h"
#include "imagAcum.h"

typedef struct teaxtender {
  int si;
  int pxoe, pxes, pxno, pxsu;
  } * taextender;

typedef struct temargen{
  int oe, es, no, su;
  } * tmargen;

void piximagAcumalloc (timagAcum imagAcum, int tx, int ty)
{
  int tam;
  int y;
  tam = tx * ty;
  imagAcum -> apixels = (int *) malloc (tam * sizeof(int)) ;
  imagAcum -> pix     = (int **) malloc (ty * sizeof (int *)) ;
  for (y=0; y<ty; y++)
    imagAcum -> pix[y] = & (imagAcum -> apixels [y*tx]) ;
  imagAcum -> ani     = (int *) malloc (tam * sizeof(int)) ;
  imagAcum -> ni      = (int **) malloc (ty * sizeof (int *)) ;
  for (y=0; y<ty; y++)
    imagAcum -> ni [y] = & (imagAcum -> ani     [y*tx]) ;
}

void piximagAcumcero (timagAcum imagAcum, int tx, int ty)
{
  int x, y;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    imagAcum -> pix[y][x] = 0 ;
    imagAcum -> ni [y][x] = 0 ;
    }
}

timagAcum creaImagenAcum (int ampl)
{
  timagAcum nimagAcum;
  int tx, ty;
  tx = 1;
  ty = 1;
  nimagAcum = (timagAcum) malloc (sizeof(struct teimagAcum) );
  nimagAcum -> tx      = tx;
  nimagAcum -> ty      = ty;
  nimagAcum -> ampl    = ampl ;
  nimagAcum -> cdgx    = 0 ;
  nimagAcum -> cdgy    = 0 ;
  nimagAcum -> n       = 0 ;
  nimagAcum -> grfondo = 0 ;
  piximagAcumalloc (nimagAcum, tx, ty) ;
  piximagAcumcero  (nimagAcum, tx, ty) ;
  return  nimagAcum ;
}

void piximagAcumfree (timagAcum imagAcum)
{
  free (imagAcum -> apixels) ;
  free (imagAcum -> pix) ;
  free (imagAcum -> ani    ) ;
  free (imagAcum -> ni ) ;
}

void imagAcumfree (timagAcum imagAcum)
{
  piximagAcumfree (imagAcum);
  free (imagAcum) ;
}

void imagAcumImprime (timagAcum imagAcum)
{
  int tx, ty, x, y;
  int ** pix;
  tx  = imagAcum -> tx ;
  ty  = imagAcum -> ty ;
  pix = imagAcum -> pix ;
  for (y=0; y<ty; y++) {
    printf("%3d:",y);
    for (x=0; x<tx; x++)
      printf (" %4d", pix[y][x]);
    printf ("\n");
    }
  printf ("\n");
}

void imagAcumyVentanaCentrados (tmargen margen,
                                timagAcum imagAcum,
                                tvent vent)
{
  int vcdgx, vcdgy;
  int ampl;
  ampl = imagAcum -> ampl;
  cdgVentana (&vcdgx, &vcdgy, vent, ampl);
  // printf ("cdgx =%4d cdgy =%4d\n", vcdgx, vcdgy);
  margen -> oe = imagAcum ->cdgx - vcdgx ;
  margen -> es = imagAcum ->tx - (vent ->tx * ampl) - margen -> oe ;
  margen -> no = imagAcum ->cdgy - vcdgy ;
  margen -> su = imagAcum ->ty - (vent ->ty * ampl) - margen -> no ;
}

void extension (taextender aextender, tmargen margen)
{
  aextender -> si = FALSE;
  if (margen -> oe < 0) {
    aextender -> pxoe = - margen -> oe;
    margen -> oe = 0;
    aextender -> si = TRUE ;
    }
  else
    aextender -> pxoe = 0;
  if (margen -> es < 0) {
    aextender -> pxes = - margen -> es;
    margen -> es = 0;
    aextender -> si = TRUE ;
    }
  else
    aextender -> pxes = 0;
  if (margen -> no < 0) {
    aextender -> pxno = - margen -> no;
    margen -> no = 0;
    aextender -> si = TRUE ;
    }
  else
    aextender -> pxno = 0;
  if (margen -> su < 0) {
    aextender -> pxsu = - margen -> su;
    margen -> su = 0;
    aextender -> si = TRUE ;
    }
  else
    aextender -> pxsu = 0;
}

void imagAcumExtiende (timagAcum imagAcum,
                       taextender aextender)
{
  int pxoe, pxes, pxno, pxsu;
  struct teimagAcum eimagAcumaux;
  timagAcum imagAcumaux;
  int tx, ty, txaux, tyaux;
  int grfondo ;
  int ** pix, ** pixaux;
  int ** ni , ** niaux;
  int x, y ;
  imagAcumaux = & eimagAcumaux;
  pxoe = aextender -> pxoe ;
  pxes = aextender -> pxes ;
  pxno = aextender -> pxno ;
  pxsu = aextender -> pxsu ;
  pix     = imagAcum -> pix;
  ni      = imagAcum -> ni ;
  tx      = imagAcum -> tx ;
  ty      = imagAcum -> ty ;
  grfondo = imagAcum -> grfondo ;
  txaux = tx + pxoe + pxes ;
  tyaux = ty + pxno + pxsu ;
/*
  printf ("ocre.imagAcum.imagAcumExtiende pxoe=%3d tx=%3d pxes=%3d txaux=%3d\n",
                                          pxoe, tx, pxes, txaux);
  printf ("              imagAcumExtiende pxno=%3d ty=%3d pxsu=%3d tyaux=%3d\n",
                                          pxno, ty, pxsu, tyaux);
*/
  // nueva base y vector
  piximagAcumalloc (imagAcumaux, txaux, tyaux);
  pixaux = imagAcumaux -> pix ;
  niaux  = imagAcumaux -> ni  ;
  // copia
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pixaux[y+pxno][x+pxoe] = pix[y][x];
    niaux [y+pxno][x+pxoe] = ni [y][x];
    }
  // rellena margenes
  if (pxoe > 0)
    for (x=0; x<pxoe; x++)
    for (y=0; y<tyaux; y++) {
      pixaux[y][x] = grfondo ;
      niaux [y][x] = 0;
      }
  if (pxes > 0)
    for (x=0; x<pxes; x++)
    for (y=0; y<tyaux; y++) {
      pixaux[y][x+pxoe+tx] = grfondo ;
      niaux [y][x+pxoe+tx] = 0;
      }
  if (pxno > 0)
    for (y=0; y<pxno; y++)
    for (x=0; x<tx; x++) {
      pixaux[y][x+pxoe] = grfondo ;
      niaux [y][x+pxoe] = 0;
      }
  if (pxsu > 0)
    for (y=0; y<pxsu; y++)
    for  (x=0; x<tx; x++) {
      pixaux[y+pxno+ty][x+pxoe] = grfondo ;
      niaux [y+pxno+ty][x+pxoe] = 0;
      }
  // poner base y vector nuevos
  piximagAcumfree (imagAcum);
  imagAcum -> apixels = imagAcumaux -> apixels ;
  imagAcum -> pix     = imagAcumaux -> pix     ;
  imagAcum -> ani     = imagAcumaux -> ani     ;
  imagAcum -> ni      = imagAcumaux -> ni      ;
  imagAcum -> tx      = txaux ;
  imagAcum -> ty      = tyaux ;
  imagAcum -> grfondo = grfondo ;
  imagAcum -> cdgx    += pxoe ;
  imagAcum -> cdgy    += pxno ;
}

void imagAcumSumaMargenes (timagAcum imagAcum, tmargen margen, int grfondov)
{
  // los margenes; 0..x1 y x2..x3 inclusive
  int x1, x2, x3, y1, y2, y3;
  int x, y;
  int ** pix;
  x1 = margen -> oe - 1 ;
  x2 = imagAcum -> tx - margen -> es ;
  x3 = imagAcum -> tx - 1 ;
  y1 = margen -> no - 1 ;
  y2 = imagAcum -> ty - margen -> su ;
  y3 = imagAcum -> ty - 1 ;
  pix = imagAcum -> pix;
  // norte, completo
  for (y=0; y<=y1; y++)
  for (x=0; x<=x3; x++)
    pix[y][x] += grfondov ;
  // sur, completo
  for (y=y2; y<=y3; y++)
  for (x=0; x<=x3; x++)
    pix[y][x] += grfondov ;
  // oeste, parte
  for (y=y1+1; y<y2; y++)
  for (x=0; x<=x1; x++)
    pix[y][x] += grfondov ;
  // este, parte
  for (y=y1+1; y<y2; y++)
  for (x=x2; x<=x3; x++)
    pix[y][x] += grfondov ;
}


void imagAcumSuma (timagAcum imagAcum,
                   tvent vent, tmargen margen)
{
  int ampl;
  int x, y, ix, iy;
  int tx, ty;
  int dx, dy;
  int ** pix;
  char ** vpix;
  int ** ni ;
  // int * conv;
  int grfondov = 70;
  dx   = margen -> oe ;
  dy   = margen -> no ;
  pix  = imagAcum -> pix ;
  ni   = imagAcum -> ni  ;
  tx   = vent -> tx ;
  ty   = vent -> ty ;
  vpix = vent -> pix ;
  // conv = vent -> conv ;
  ampl = imagAcum -> ampl ;
  if (dx < 0) {
    printf ("ocre.imagAcum.imagenAcumSum: error dx =%4d\n", dx);
    exit (15);
    }
  if (dy < 0) {
    printf ("ocre.imagAcum.imagenAcumSum: error dy =%4d\n", dy);
    exit (15);
    }
  if (imagAcum->tx < (tx * ampl + dx) ) {
    printf ("ocre.imagAcum.imagenAcumSum: error imagAcum->tx =%4d, tx*ampl+dx = %4d\n",
            imagAcum->tx, tx*ampl + dx);
    exit (15);
    }
  if (imagAcum->ty < (ty * ampl + dy) ) {
    printf ("ocre.imagAcum.imagenAcumSum: error imagAcum->ty =%4d, ty*ampl+dy = %4d\n",
            imagAcum->ty, tx*ampl + dy);
    exit (15);
    }
  for (y=0; y<ty; y++)
  for (iy=0; iy<ampl; iy++)
  for (x=0; x<tx; x++)
  for (ix=0; ix<ampl; ix++) {
/*
    printf ("%4d, %4d %4d %4d %4d %4d\n",
            y, iy, x, ix, y*ampl+iy+dy, x*ampl+ix+dx );
*/
    pix[y*ampl+iy+dy][x*ampl+ix+dx] += ( 255 - (vpix[y][x] & 0xFF) );
    ni [y*ampl+iy+dy][x*ampl+ix+dx] ++;
    }
  imagAcum -> n ++ ;
  imagAcumSumaMargenes (imagAcum, margen, grfondov) ;
  imagAcum -> grfondo += grfondov ;
}

void anyadeImagAcum (timagAcum imagAcum, tvent vent)
{
  struct teaxtender eaextender, * aextender;
  struct temargen   emargen,   * margen;
  tvent ventam;
  aextender = & eaextender ;
  margen    = & emargen ;
  // imagAcumyVentanaCentrados (margen, imagAcum, vent); //1
  ventanaAmpliaVentana (& ventam, vent, 1);
  imagAcumyVentanaCentrados (margen, imagAcum, ventam);
  //
  extension (aextender, margen);
  if (aextender -> si)
    imagAcumExtiende (imagAcum, aextender);
  // imagAcumSuma (imagAcum, vent, margen);  //1
  imagAcumSuma (imagAcum, ventam, margen);
  // imagAcumImprime (imagAcum);
}

int pixmaxImagAcum (timagAcum imagAcum)
{
  int x, y, tx, ty;
  int ** pix;
  int mpix, pixxy;
  tx  = imagAcum -> tx ;
  ty  = imagAcum -> ty ;
  pix = imagAcum -> pix ;
  mpix = 0;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++){
    pixxy = pix[y][x] ;
    if (pixxy > mpix) {
      mpix = pixxy ;
      // printf ("ocre.imagAcum.pixmaxImagAcum: x=%3d y=%3d %6d\n", y, x, mpix);
      }
    }
  return mpix;
}

void imagenDeImagenAcum (timagf * nimag, timagAcum imagAcum)
{
  int tx, ty;
  int x,  y;
  char ** vpix;
  int  ** iapix;
  int tam;
  timagf imag;
  int pmax ;
  int pmaxEntre2;
  tx = imagAcum -> tx;
  ty = imagAcum -> ty;
  tam  = tx * ty ;
  imag = imagfalloc ();
  imag -> tx     = tx ;
  imag -> ty     = ty ;
  imag -> apixels = (char *) malloc (tam * sizeof (char)) ;
  imag -> ven0   = ventBaseDeImagf (imag);
  pmax = pixmaxImagAcum (imagAcum);
  // printf ("%3d\n", pmax);
  pmaxEntre2 = pmax / 2;
  vpix = imag -> ven0 -> pix ;
  iapix = imagAcum -> pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
/*
    int denom;
    denom = max (imagAcum->n/2, imagAcum->ni [y][x]);
    vpix [y][x] = 255 - (iapix[y][x] + (denom/2)) / denom ;
*/
    vpix [y][x] = 255 - (iapix[y][x]*255 + pmaxEntre2) / pmax ;
    }
  *nimag = imag;
}

