
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "base.h"
#include "imag.h"
#include "imag0.h"
#include "imagl.h"

// typedef struct teimagl{
//   int tx, ty;
//   int * apixels;
//   int ** pix;
//   } * timagl;


timagl imaglalloc ()
{
  timagl imagl;
  imagl = (timagl) malloc (sizeof(struct teimagl));
  imagl->tx      = 0;
  imagl->ty      = 0;
  imagl->apixels = (int *) 0L;
  imagl->pix     = (int **) 0L;
  return imagl;
}

timagl imaglalloc2 (int tx, int ty)
{
  int y;
  int ** v;
  timagl imagl;
  imagl = imaglalloc ();
  imagl->tx      = tx;
  imagl->ty      = ty;
  imagl->apixels = (int *) malloc (tx * ty * sizeof(int));
  v  = (int **) malloc (ty * sizeof(int *));
  for (y=0; y<ty; y++)
    v[y] = & (imagl->apixels[y*tx]) ;
  imagl->pix = v;
  return imagl;
}

void destruyeImagenL (timagl imagl)
{
  free (imagl->apixels);
  free (imagl->pix);
  free (imagl);
}

void imagenlVarsH (timagl *nimagl, tvent vent, int delH)
{
  int tx, ty, x, y;
  int ** pixl1;
  int ** pixl2;
  char ** pix;
  int dif;
  int delHd2;
  int xmin, xmax;
  timagl imagl1;
  timagl imagl2;
  delHd2 = delH / 2;
  tx = vent->tx;
  ty = vent->ty;
  // if (delH >= tx) {
  //   printf ("ocre: error en imagenlVarsH, delH: %6d >= vent->tx: %6d\n", delH, tx);
  //   exit (1);
  //   }
  pix  = vent->pix;
  imagl1 = imaglalloc2 (tx, ty);
  pixl1 =imagl1->pix;
  for (y=0; y < ty; y++){
    pixl1[y][0] = 0;
    for (x=0; x < (tx - 1); x++){
      dif = (pix[y][x+1] & 0x0FF) - (pix[y][x] & 0x0FF);
      pixl1[y][x+1] = pixl1[y][x] + abs(dif);
      }
    }
//  escribeEsqImagenl (imagl1);      // <<<<<
  imagl2 = imaglalloc2 (tx, ty);
  pixl2 =imagl2->pix;
  for (x=0; x < tx; x++){
    xmin = max(x-delHd2,0);
    xmax = min(x+delHd2,tx-1);
    for (y=0; y < ty; y++){
      pixl2[y][x] = pixl1[y][xmax] - pixl1[y][xmin];
      }
    }
  destruyeImagenL (imagl1);
  *nimagl = imagl2;
}

void imagenlVarsV (timagl *nimagl, tvent vent, int delV)
{
  int tx, ty, x, y;
  int ** pixl1;
  int ** pixl2;
  char ** pix;
  int dif;
  int delVd2;
  int ymin, ymax;
  timagl imagl1;
  timagl imagl2;
  delVd2 = delV / 2;
  tx = vent->tx;
  ty = vent->ty;
  // if (delV >= ty) {
  //   printf ("ocre: error en imagenlVarsV, delV: %6d >= vent->ty: %6d\n", delV, ty);
  //   exit (1);
  //   }
  pix  = vent->pix;
  imagl1 = imaglalloc2 (tx, ty);
  pixl1 =imagl1->pix;
  for (x=0; x < tx; x++){
    pixl1[0][x] = 0;
    for (y=0; y < (ty - 1); y++){
      dif = (pix[y+1][x] & 0x0FF) - (pix[y][x] & 0x0FF);
      pixl1[y+1][x] = pixl1[y][x] + abs(dif);
      }
    }
//  escribeEsqImagenl (imagl1);      // <<<<<
  imagl2 = imaglalloc2 (tx, ty);
  pixl2 =imagl2->pix;
  for (y=0; y < ty; y++){
    ymin = max(y-delVd2,0);
    ymax = min(y+delVd2,ty-1);
    for (x=0; x < tx; x++){
      pixl2[y][x] = pixl1[ymax][x] - pixl1[ymin][x];
      }
    }
  destruyeImagenL (imagl1);
  *nimagl = imagl2;
}

void maxminDeimagenl (int *max, int *min, timagl imagl)
{
  int tx, ty, x, y;
  int ** pix;
  int mx, mn;
  //  int xminimo, yminimo;
  tx = imagl->tx;
  ty = imagl->ty;
//  printf ("tx :%5d ty:%5d\n", tx, ty);
  pix  =imagl ->pix;
  mx = mn = (pix[0][0] & 0x0FF);
  for (y=0; y < ty; y++){
    for (x=0; x < tx; x++){
      if (pix[y][x] < mn){
        mn = pix[y][x] ;
        // xminimo = x;
        // yminimo = y;
        }
      if (pix[y][x] > mx)
        mx = pix[y][x] ;
      }
    }
//  printf ("mx :%5d mn:%5d\n", mx, mn);
//  printf ("xminimo :%5d yminimo:%5d\n", xminimo, yminimo);
  *max = mx;
  *min = mn;
}

void imagenlDiferVarhVarv2 (timagl *nimagl, timagl imagvh, timagl imagvv)
{
  int tx, ty, x, y;
  timagl imagl;
  int ** pix;
  int ** pixvh;
  int ** pixvv;
  tx = imagvh->tx;
  ty = imagvh->ty;
  imagl = imaglalloc2 (tx, ty);
  pix    =imagl ->pix;
  pixvh  =imagvh->pix;
  pixvv  =imagvv->pix;
  for (y=0; y < ty; y++){
    for (x=0; x < tx; x++){
      pix[y][x] = pixvh[y][x] - pixvv[y][x];
      }
    }
  *nimagl = imagl;
}

void imagenlDiferVarhVarv (timagl *nimagl, timagl imagvh, timagl imagvv)
{
  int tx, ty, x, y;
  timagl imagl;
  int ** pix;
  int ** pixvh;
  int ** pixvv;
  int min, max, mn;
  // int dif;
  tx = imagvh->tx;
  ty = imagvh->ty;
  imagl = imaglalloc2 (tx, ty);
  pix    =imagl ->pix;
  pixvh  =imagvh->pix;
  pixvv  =imagvv->pix;
  maxminDeimagenl (&max, &min, imagvv);
  // dif = max - min;
  // mn = min(10,min);
  mn = 4;
  for (y=0; y < ty; y++){
    for (x=0; x < tx; x++){
      pix[y][x] = pixvh[y][x] / max(pixvv[y][x],mn);
      }
    }
  *nimagl = imagl;
}

void imagenlSumaVarhVarv (timagl *nimagl, timagl imagvh, timagl imagvv)
{
  int tx, ty, x, y;
  timagl imagl;
  int ** pix;
  int ** pixvh;
  int ** pixvv;
//  int min, max, dif, mn;
  tx = imagvh->tx;
  ty = imagvh->ty;
  imagl = imaglalloc2 (tx, ty);
  pix    =imagl ->pix;
  pixvh  =imagvh->pix;
  pixvv  =imagvv->pix;
//  maxminDeimagenl (&max, &min, imagvv);
//  dif = max - min;
//  mn = min(10,min);
//  mn = 4;
  for (y=0; y < ty; y++){
    for (x=0; x < tx; x++){
      pix[y][x] = pixvh[y][x] + pixvv[y][x];
      }
    }
  *nimagl = imagl;
}

void imagenfDeimagenl (timagf *nimag, timagl imagl)
{
  int tx, ty, x, y;
  int ** pixl;
  char ** pix;
  int max, min, dif, mesca, minmenosmesca;
  timagf imag;
  // maximo y minimo
  maxminDeimagenl (&max, &min, imagl);
  tx = imagl->tx;
  ty = imagl->ty;
  //
  creaImagenPlana (&imag, 0, tx, ty);
  dif = max - min;
//  printf ("min: %7d max %7d dif: % 7d\n", min, max, dif);
  // ajuste a 255 niveles
  mesca = (dif / 255) / 2;       // medio escalon
  minmenosmesca = min - mesca;
//  printf ("mesca: %7d minmenosmesca %7d\n", mesca, minmenosmesca);
  pixl = imagl ->pix;
  pix  = imag->ven0->pix;
  for (y=0; y < ty; y++){
    for (x=0; x < tx; x++){
      pix[y][x] = (pixl[y][x] - minmenosmesca) * 255 / dif ;
      }
    }
  *nimag = imag;
}

void escribeEsqImagenl (timagl imagl)
{
  int tx, ty, x, y;
  int ** pix;
  tx = min(10,imagl->tx);
  ty = min(10,imagl->ty);
  pix  =imagl ->pix;
  for (y=0; y < ty; y++){
    for (x=0; x < tx; x++){
      printf(" %5d", pix[y][x]);
      }
    printf("\n");
    }
  printf("\n");
}

/*
int mc[5][5] = { { 0,  2,  3,  2,  0},
                 {-2,  0,  2,  0, -2},
                 {-3, -2,  0, -2, -3},
                 {-2,  0,  2,  0, -2},
                 { 0,  2,  3,  2,  0} };
int txc = 5;
int tyc = 5;

int mc[7][7] = { { 0,  2,  3,  3,  3,  2,  0},
                 {-2,  0,  2,  3,  2,  0, -2},
                 {-3, -2,  0,  2,  0, -2, -3},
                 {-3, -3, -2,  0, -2, -3, -3},
                 {-3, -2,  0,  2,  0, -2, -3},
                 {-2,  0,  2,  3,  2,  0, -2},
                 { 0,  2,  3,  3,  3,  2,  0} };
int txc = 7;
int tyc = 7;
*/

int mc[9][9] = { { 0,  2,  3,  4,  4,  4,  3,  2,  0},
                 {-2,  0,  2,  3,  4,  3,  2,  0, -2},
                 {-3, -2,  0,  2,  3,  2,  0, -2, -3},
                 {-4, -3, -2,  0,  2,  0, -2, -3, -4},
                 {-4, -4, -3, -2,  0, -2, -3, -4, -4},
                 {-4, -3, -2,  0,  2,  0, -2, -3, -4},
                 {-3, -3,  0,  2,  3,  2,  0, -2, -3},
                 {-2,  0,  2,  3,  4,  3,  2,  0, -2},
                 { 0,  2,  3,  4,  4,  4,  3,  2,  0} };
int txc = 9;
int tyc = 9;

/*
*/

void imagenlConvolucion2 (timagl *nimagl, tvent vent)
{
  int tx, ty, x, y;
  int ** pixl1;
  char ** pix;
  int sum;
  int maxpix1, minpix1;
  int xc, yc;
  timagl imagl1;
  tx = vent->tx;
  ty = vent->ty;
  pix  = vent->pix;
  imagl1 = imaglalloc2 (tx, ty);
  pixl1 =imagl1->pix;
  maxpix1 = 0;
  minpix1 = 0;
  for (x=0; x < tx-txc; x++)
  for (y=0; y < ty-tyc; y++){
    sum = 0;
    for (xc=0; xc < txc; xc++)
    for (yc=0; yc < tyc; yc++) 
      sum += (pix[y+yc][x+xc] & 0xFF) * mc[yc][xc];
    pixl1 [y][x] = sum; 
    if (sum < minpix1)
      minpix1 = sum;
    if (sum > maxpix1)
      maxpix1 = sum;
    }
  *nimagl = imagl1;
}

void imagenlConvolucion (timagl *nimagl, tvent vent)
{
  int tx, ty, x, y;
  int ** pixl1;
  char ** pix;
  int sum;
  int maxpix1, minpix1;
  int xc, yc;
  timagl imagl1;
  int n, s, s2;
  float dt;
  int sumr;
  n = txc * tyc;
  tx = vent->tx;
  ty = vent->ty;
  pix  = vent->pix;
  imagl1 = imaglalloc2 (tx, ty);
  pixl1 =imagl1->pix;
  maxpix1 = 0;
  minpix1 = 0;
  for (x=0; x < tx-txc; x++)
  for (y=0; y < ty-tyc; y++){
    sum = 0;
    s = 0; s2 = 0;
    for (xc=0; xc < txc; xc++)
    for (yc=0; yc < tyc; yc++) {
      sum += (pix[y+yc][x+xc] & 0xFF) * mc[yc][xc];
      s += (pix[y+yc][x+xc] & 0xFF) ;
      s2 += (pix[y+yc][x+xc] & 0xFF) * (pix[y+yc][x+xc] & 0xFF) ;
      }
    dt = sqrt ( s2/n - s*s/(n*n)) ;
    pixl1 [y][x] = sumr = (sum * 256) / (dt + 32); 
    if (sumr < minpix1)
      minpix1 = sumr;
    if (sumr > maxpix1)
      maxpix1 = sumr;
    }
  *nimagl = imagl1;
}

void cruces_escaque (timagf *nimag, tvent vent)
{
  timagl imagl1;
  int tx, ty;
  char ** pix;
  int ** pixl1;
  int s00, s01, s10, s11;
  int x, y, contr;
  tx = vent->tx;
  ty = vent->ty;
  pix  = vent->pix;
  imagl1 = imaglalloc2 (tx, ty);
  pixl1 =imagl1->pix;
  for (y=0; y < ty-5; y++){
    for (x=0; x < tx-5; x++) {
      s00 = (pix [y][x]     &0xFF) + (pix [y][x+1]   &0xFF) +
            (pix [y+1][x]   &0xFF) + (pix[y+1][x+1]  &0xFF) ;
      s01 = (pix [y][x+3]   &0xFF) + (pix [y][x+4]   &0xFF) +
            (pix [y+1][x+3] &0xFF) + (pix[y+1][x+4]  &0xFF) ;
      s10 = (pix [y+3][x]   &0xFF) + (pix [y+3][x+1] &0xFF) +
            (pix [y+4][x]   &0xFF) + (pix[y+4][x+1]  &0xFF) ;
      s11 = (pix [y+3][x+3] &0xFF) + (pix [y+3][x+4] &0xFF) +
            (pix [y+4][x+3] &0xFF) + (pix[y+4][x+4]  &0xFF) ;
      contr = (s01 -s00) * (s10 - s11);
      if (contr < 0)
        pixl1 [y][x] = 0;
      else
        pixl1 [y][x] = trunc(sqrt (contr)) ;
      }
    }
  imagenfDeimagenl (nimag, imagl1);
}
