
#include <stdlib.h>
#include <stdio.h>

#include "lista.h"

tnodol nodolNuevo (tpgen g)
{
  tnodol nnodol;
  nnodol = (tnodol) malloc (sizeof(struct nodol));
  nnodol->aitem = g ;
  nnodol->siguiente = (tnodol) 0L;
  nnodol->anterior  = (tnodol) 0L;
  return nnodol ;
}

lista listaNueva ()
{
  lista nlista;
  nlista = (lista) malloc (sizeof(struct lista));
  nlista->primero = (tnodol) 0L;
  nlista->ultimo  = (tnodol) 0L;
  return nlista ;
}

Boolean listaVacia (lista l)
{
  return l->primero == (tnodol) 0L ;
}

void aniadeacomlista (lista l, tpgen g )
{
  tnodol nnodol;
  nnodol = nodolNuevo (g);
  if (l->primero == (tnodol) 0L) {
    l->primero = nnodol ;
    l->ultimo  = nnodol ;
    }
  else {
    nnodol->siguiente    = l ->primero ;
    l->primero->anterior = nnodol ;
    l->primero           = nnodol ;
    }
}

void aniadeNafinlista (lista l, tnodol nodol)
{
  if (l->primero == (tnodol) 0L) {
    l->primero = nodol ;
    l->ultimo  = nodol ;
    }
  else {
    nodol->anterior     = l ->ultimo ;
    l->ultimo->siguiente = nodol ;
    l ->ultimo           = nodol ;
    }
}

void aniadeafinlista (lista l, tpgen g )
{
  tnodol nnodol;
  nnodol = nodolNuevo (g);
  aniadeNafinlista (l, nnodol);
}

void pasalistaafinlista (lista ld, lista lo)
{
  if (listaVacia (lo))
    return ;
  else if (ld->primero == (tnodol) 0L) {
    ld->primero = lo->primero ;
    ld->ultimo  = lo->ultimo ;
    }
  else {
    lo->primero->anterior     = ld->ultimo ;
    ld->ultimo->siguiente     = lo->primero ;
    ld->ultimo                = lo->ultimo ;
    }
  lo->primero = (tnodol) 0L ;
  lo->ultimo  = (tnodol) 0L ;
}


void aniadealistaAntes (lista l, tpgen g , tnodol nodol)
{
  if (l->primero == nodol)
    aniadeacomlista (l, g);
  else {
    tnodol nnodol;
    nnodol                     = nodolNuevo (g);
    nnodol->siguiente          = nodol ;
    nnodol->anterior           = nodol->anterior;
    nodol->anterior->siguiente = nnodol;
    nodol->anterior            = nnodol;
  }
}

lista copiaLista (lista l)
{
  lista ln;
  tnodol nodol;
  ln = listaNueva ();
  for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
    aniadeafinlista (ln, nodol->aitem);
    }
  return ln;
}

lista copiaListaReves (lista l)
{
  lista ln;
  tnodol nodol;
  ln = listaNueva ();
  for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
    aniadeacomlista (ln, nodol->aitem);
    }
  return ln;
}

lista headNlista (lista l, int n)
{
  lista ln;
  int i;
  tnodol nodol;
  ln = listaNueva ();
  i = 0;
  for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
    aniadeafinlista (ln, nodol->aitem);
    if (++i == n) break;
    }
  return ln;
}

void eliminaNdelista (lista l, tnodol nodol)
{
  tnodol nodoantes, nododespues;
  if (listaVacia(l)) {
    printf ("error en lista.eliminaNdelista, lista vacia\n");
    exit (1);
    }
  if (l->primero == nodol)
    if (l->ultimo == nodol) {
      l->primero = 0L;
      l->ultimo  = 0L;
      }
    else {
      l->primero = l->primero->siguiente;
      l->primero->anterior = 0L;
      }
  else
    if (l->ultimo == nodol) {
      l->ultimo = l->ultimo->anterior;
      l->ultimo->siguiente = 0L;
      }
    else {
      nodoantes   = nodol->anterior;
      nododespues = nodol->siguiente;
      nodoantes->siguiente  = nododespues;
      nododespues->anterior = nodoantes;
      }
}

void primerNodoAlFinal (lista l)
{
  tnodol nodo0, nodo1, nodoN;
  if (l->primero != l->ultimo) {
    nodo0            = l->primero;
    nodo1            = nodo0->siguiente;
    nodoN            = l->ultimo;
    l->primero       = nodo1;
    l->ultimo        = nodo0;
    nodo1->anterior  = 0L;
    nodoN->siguiente = nodo0;
    nodo0->anterior  = nodoN;
    nodo0->siguiente = 0L;
    }
  // else nada
}

Boolean eliminaItemdelista (lista l, tpgen item)
{
  tnodol nodol;
  Boolean eliminado;
  eliminado = FALSE;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
      if (nodol->aitem == item){
        eliminaNdelista (l, nodol);
        eliminado = TRUE;
	break ;
	}
      }
  return eliminado;
}

Boolean cambiaItemdelista (lista ld, lista lo, tpgen item)
{
  Boolean eliminado;
  eliminado = eliminaItemdelista (lo, item);
  if (eliminado)
    aniadeafinlista (ld, item);
  return eliminado;
}

void substituyePorListaNodo  (lista l, lista la , tnodol nodol)
{
  if (  listaVacia(la) ) 
    eliminaNdelista (l, nodol);
  else {
    /* izq */
    la->primero->anterior   = nodol->anterior;
    if (l->primero == nodol)
      l->primero = la->primero ;
    else
      nodol->anterior->siguiente = la->primero;
    /* der */
    la->ultimo->siguiente   = nodol->siguiente;
    if (l->ultimo == nodol)
      l->ultimo = la->ultimo ;
    else 
      nodol->siguiente->anterior = la->ultimo ; 
    }
  free (la);
}

void recorreListaAplicando (lista l, void fn(tpgen))
{
  tnodol nodol;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
      fn (nodol->aitem);
      }
}

void recorreListaAplicandoMasdat (lista l, tpgen dat, void fn(tpgen, tpgen))
{
  tnodol nodol;
  for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
    fn (nodol->aitem, dat);
    }
}

void eliminaDeListaSiFuncResul (lista l, Boolean fn(tpgen), Boolean resul)
{
  tnodol nodol;
  tnodol nodosig;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodosig) {
      nodosig = nodol->siguiente;
      if (fn (nodol->aitem) == resul) {
	eliminaNdelista (l, nodol);
        // nodol->anterior = nodol->siguiente = 0L;
        }
      }
}

void eliminaDeListaSiFuncEResul (lista l, tpgen dat, Boolean fn(tpgen, tpgen), Boolean resul)
{
  tnodol nodol;
  tnodol nodosig;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodosig) {
      nodosig = nodol->siguiente;
      if (fn (nodol->aitem, dat) == resul) {
	eliminaNdelista (l, nodol);
        // nodol->anterior = nodol->siguiente = 0L;
        }
      }
}

tnodol buscaEnListaSiFuncEResul (lista l, tpgen dat, Boolean fn(tpgen, tpgen), Boolean resul)
{
  tnodol nodol;
  tnodol nodosig;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodosig) {
      nodosig = nodol->siguiente;
      if (fn (nodol->aitem, dat) == resul)
	return  nodol;
      }
  return (tnodol) 0L;
}

tnodol maximIEnlista (lista l, int fn(tpgen))
{
  tnodol nodol;
  tnodol nodomax;
  tnodol nodosig;
  int v, vmax;
  nodomax = 0L;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodosig) {
      nodosig = nodol->siguiente;
      v = fn(nodol->aitem);
      if ((nodol == l->primero) ||
          (v > vmax) ) {
        vmax = v;
        nodomax = nodol;
        }
      }
  return nodomax;
}

tnodol minimIEnlista (lista l, int fn(tpgen))
{
  tnodol nodol;
  tnodol nodomin;
  tnodol nodosig;
  int v, vmin;
  nodomin = 0L;
  if (l->primero != 0L)
    for (nodol = l->primero; nodol != 0L;nodol = nodosig) {
      nodosig = nodol->siguiente;
      v = fn(nodol->aitem);
      if ((nodol == l->primero) ||
          (v < vmin) ) {
        vmin = v;
        nodomin = nodol;
        }
      }
  return nodomin;
}

lista ordenadaLista (lista l, int fn(tpgen))
{
  lista l2, l3;
  tnodol nmax;
  l2 = copiaLista (l);
  l3 = listaNueva ();
  // printf ("lista.ordenadaLista 0\n");
  while (! listaVacia(l2)) {
    // printf ("lista.ordenadaLista 1\n");
    nmax =  maximIEnlista (l2, fn);
    eliminaNdelista (l2, nmax);
    nmax->siguiente = (tnodol) 0L;
    nmax->anterior  = (tnodol) 0L;
    aniadeNafinlista (l3, nmax);
    }
  return l3;
}

int longLista (lista l)
{
  int i=0;
  tnodol nodol;
  for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
    i++ ;
    }
  return  i ;
}

void plongLista2 (lista l)
{
  tnodol nodol;
  printf ("(");
  for (nodol = l->primero; nodol != 0L;nodol = nodol->siguiente) {
    printf (" %1d", longLista (nodol->aitem));
    }
  printf (")\n");
}

tnodol enesimoNodoDeLista (lista l, int n)
{
  int i;
  tnodol nodol;
  i = 1;
  nodol = l->primero;
  while ((i < n) && (nodol != (tnodol)0L)){
    i++;
    nodol = nodol->siguiente;
    }
  return nodol;
}

void liberaNodosYlista (lista l)
{
  tnodol nodol, nodolsig;
  for (nodol = l->primero; nodol != 0L;nodol = nodolsig) {
    nodolsig = nodol->siguiente ;
    free (nodol);
    }
  free (l);
}

void liberaItemsNodosYlista (lista l)
{
  recorreListaAplicando (l, free);
  liberaNodosYlista (l);
}

void intermcambiaNodosDelistas (lista l1, lista l2)
{
  tnodol nodoPrimeroL1, nodoUltimoL1;
  nodoPrimeroL1 = l1->primero;
  nodoUltimoL1  = l1->ultimo;
  l1->primero   = l2->primero;
  l1->ultimo    = l2->ultimo;
  l2->primero   = nodoPrimeroL1;
  l2->ultimo    = nodoUltimoL1;
}

Boolean relacionItemLista (tpgen it, lista l, Boolean r(tpgen, tpgen))
{
  tnodol nodol;
  for (nodol = l->primero; nodol != 0L; nodol = nodol->siguiente) {
    if (r (it, nodol->aitem))
      return TRUE;
    }
   return FALSE;
}

lista cierreTransitivo (lista l, Boolean r(tpgen, tpgen))
{
  tnodol nodol, nodoct;
  tpgen it;
  lista ct;        // lista de listas
  lista prim;      // primera lista  relacionada con  it
  lista lx;
  lista cl;
  ct = listaNueva ();
  // anyade cada elemento de  l  al cierre transitivo
  for (nodol = l->primero; nodol != 0L; nodol = nodol->siguiente) {
    it = nodol->aitem;
    prim = 0L;
    // recorre la lista de clases
    for (nodoct = ct->primero; nodoct != 0L; nodoct = nodoct->siguiente) {
      cl = nodoct->aitem;
      if (relacionItemLista (it, cl, r)) {
        if (prim == 0L)
          prim = cl;
        else {
          pasalistaafinlista (prim, cl);
          eliminaNdelista (ct, nodoct);
          free (nodoct);  // libera nodoct
          }
        }
      }
    // anyade  it   al cierre transitivo
    if (prim == 0L) {
      lx = listaNueva ();
      aniadeafinlista (lx, it);
      aniadeafinlista (ct, lx);
      }
    else
      aniadeafinlista (prim, it);
    }
  return ct;
}

int tirarPrograma ()
{
  lista l;
  int n;
  n = (int) l->ultimo->siguiente->aitem;
  return n;
}

Boolean longListaMenorQue (tpgen l, tpgen tmin)
{
  lista lis;
  int tminl;
  lis = (lista) l;
  tminl = (int) tmin;
  return longLista(lis) < tminl;
}

