
#include <gdk/gdk.h>
#include <gtk/gtk.h>

#include "pixmap.h"
#include "xpm.h"

static GdkPixmap *pixmap = NULL;
static GdkPixmap *pixmap2 = NULL;

static char ** xpm_dato ;

extern tvent ventPreg;

/* Redraw the screen from the backing pixmap */
gint expose_event( GtkWidget      *widget,
                   GdkEventExpose *event)
{
  gdk_draw_pixmap(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                  pixmap,
                  event->area.x, event->area.y,
                  event->area.x, event->area.y,
                  event->area.width, event->area.height);
  return FALSE;
}


static GtkWidget         *widgetUl;
static GdkEventConfigure *eventUl;

/* Create a new backing pixmap of the appropriate size */
gint configure_event( GtkWidget         *widget,
                      GdkEventConfigure *event )
{
  GdkBitmap *mask;
  GtkStyle *style;
  /**/
  widgetUl = widget;
  eventUl  = event;
  /**/
  if (pixmap)
    gdk_pixmap_unref(pixmap);

  pixmap = gdk_pixmap_new(widget->window,
                          widget->allocation.width,
                          widget->allocation.height,
                          -1);
  gdk_draw_rectangle (pixmap,
                      widget->style->white_gc,
                      TRUE,
                      0, 0,
                      widget->allocation.width,
                      widget->allocation.height);
  style = gtk_widget_get_style (widget);
  if (xpm_dato)
    liberaXpmDeVentana (xpm_dato);
/*
  {
  tvent vent2;
  ventanaEnVentana(&vent2, imag->ven0, 558, 145, 40, 12);
  }
*/
  xpm_dato = xpmDeVentana (ventPreg,
                           widget->allocation.width,
                           widget->allocation.height);

  if (pixmap2)
    gdk_pixmap_unref(pixmap2);
  pixmap2 = gdk_pixmap_create_from_xpm_d(widget->window,
		                         &mask,
					 &style->bg[GTK_STATE_NORMAL],
					 (gchar **)xpm_dato);

  { int tx, ty, ncol, ncarc;
  parametrosDeXpmd (xpm_dato, &tx, &ty, &ncol, &ncarc);
  gdk_draw_pixmap (pixmap, widget->style->fg_gc[GTK_STATE_NORMAL],
		   pixmap2, 0, 0, 0, 0,
                   tx,
                   ty);
  }

  return FALSE;
}

void configureRep ()
{
  configure_event(widgetUl, eventUl);
  gdk_draw_pixmap(widgetUl->window,
                  widgetUl->style->fg_gc[GTK_WIDGET_STATE (widgetUl)],
                  pixmap, 0, 0, 0, 0,
		  widgetUl->allocation.width,
		  widgetUl->allocation.height);
}
