
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "base.h"
#include "convcar.h"
#include "distribDistans.h"
#include "distribsDistansLet.h"
#include "parecido.h"
#include "tipos.h"

void creaTipo (ttipo *ntipo)
{
  ttipo tipo;
  tipo = (ttipo) malloc (sizeof(struct tetipo));
  tipo->palabras = listaNueva();
  creaDistsdsLet (&(tipo->distsLet));
  tipo->nombre = 0L;
  *ntipo = tipo;
}

int parejasDeLetrasEnPalabra (tglifo glifoPal)
{
  tnodolglifo nodo1, nodo2;
  tglifo glifo1, glifo2;
  tlistadglifo listaGlifos;
  int np;
  np = 0;
  listaGlifos = glifoPal->listaGlifos;
  if (listaGlifos->primero->siguiente !=0L )
    for (nodo1 = listaGlifos->primero;
         nodo1->siguiente != 0L;
         nodo1 = nodo1->siguiente)
      for (nodo2 = nodo1->siguiente;
           nodo2 != 0L;
	   nodo2 = nodo2->siguiente) {
	glifo1 = nodo1->aglifo;
	glifo2 = nodo2->aglifo;
	if ( (glifo1->tipo == glifCar) &&
	     (glifo2->tipo == glifCar) )
          if ( strcmp(glifo1->letras, glifo2->letras)==0 )
	    np ++;
        }
  return np ;
}

Boolean pasaDistanciasEn1PalabraAditrbs (tdistsdsLet distsLet, tglifo glifoPal)
{
  tnodolglifo nodo1, nodo2;
  tglifo glifo1, glifo2;
  tlistadglifo listaGlifos;
  int dis;
  Boolean seAvanza;
  seAvanza = FALSE;
  listaGlifos = glifoPal->listaGlifos;
  if (listaGlifos->primero->siguiente !=0L )
    for (nodo1 = listaGlifos->primero;
         nodo1->siguiente != 0L;
         nodo1 = nodo1->siguiente)
      for (nodo2 = nodo1->siguiente;
           nodo2 != 0L;
	   nodo2 = nodo2->siguiente) {
	glifo1 = nodo1->aglifo;
	glifo2 = nodo2->aglifo;
	if ( (glifo1->tipo == glifCar) &&
	     (glifo2->tipo == glifCar) )
          if ( strcmp(glifo1->letras, glifo2->letras)==0 ){
            // char carsus[1024];
	    dis = comparaVent ( glifo1->venDeGlifo, glifo2->venDeGlifo );
            ponDiEnDistsdsLet (distsLet, glifo1->letras, dis);
	    seAvanza = TRUE;
	    /** /
            ssalidaDeUtf (carsus, glifo1->letras);
            printf ("%s", carsus);
	    printf (" dis: %5d\n", dis);
	    / **/
	    }
        }
  return seAvanza;
}

void  distanciasEn2Palabras (tglifo glifoPal1, tglifo glifoPal2)
{
  tnodolglifo nodo1, nodo2;
  tglifo glifo1, glifo2;
  tlistadglifo listaGlifos1, listaGlifos2;
  int dis;
  listaGlifos1 = glifoPal1->listaGlifos;
  listaGlifos2 = glifoPal2->listaGlifos;
  for (nodo1 = listaGlifos1->primero; nodo1 != 0L; nodo1 = nodo1->siguiente)
  for (nodo2 = listaGlifos2->primero; nodo2 != 0L; nodo2 = nodo2->siguiente){
    glifo1 = nodo1->aglifo;
    glifo2 = nodo2->aglifo;
    if ( (glifo1->tipo == glifCar) &&
	  (glifo2->tipo == glifCar) )
      if ( strcmp(glifo1->letras, glifo2->letras)==0 ){
        // char carsus[1024];
	dis = comparaVent ( glifo1->venDeGlifo, glifo2->venDeGlifo );
	/** /
        ponDiEnDistsdsLet (distsLet, glifo1->letras, dis);
        ssalidaDeUtf (carsus, glifo1->letras);
        printf ("%s", carsus);
	/ **/
	printf (" dis: %5d\n", dis);
	}
    }
}

typedef struct temaxpar{
  int np;
  tglifo glifo;
  } * tmaxpar;

#define NDMAX 5
#define NDMAXPASA 5

void distanciasDeLetraaTipo (tdistds *ndistrDis, tglifo glifoch, ttipo tipo)
{
  int nd;
  tdistds distrDis;
  tnodol nodol;
  tnodolglifo nodolglifo;
  tglifo glifoi;
  int dis;
  /** /
  printf ("> glifoch->letras:%s\n", glifoch->letras);
  / **/
  nd = 0;
  creaDistds (&distrDis);
  for ( nodol = tipo->palabras->primero;
        nodol != 0L;
	nodol = nodol->siguiente) {
    for (nodolglifo = ((tglifo)nodol->aitem)->listaGlifos->primero;
         nodolglifo != 0L;
	 nodolglifo = nodolglifo->siguiente){
      glifoi = nodolglifo->aglifo;
      /** /
      printf (">> glifoi->letras:%s\n", glifoi->letras);
      / **/
      if ( (glifoi->tipo == glifCar) &&
           (glifoch->tipo == glifCar) )
	if (strcmp(glifoi->letras, glifoch->letras) == 0) {
          dis = comparaVent ( glifoch->venDeGlifo, glifoi->venDeGlifo );
	  /** /
	  printf ("= dis:%4d\n", dis);
	  / **/
          ponDiEnDistds (distrDis, dis);
	  nd ++;
	  if (nd >= NDMAX) break;
	  }
      }
    if (nd >= NDMAX) break;
    }
  *ndistrDis = distrDis;
}

Boolean pasaDistanciasDesde1LetraaAditrbs (ttipo tipo, tglifo glifoch)
{
  int nd;
  tnodol nodol;
  tnodolglifo nodolglifo;
  tglifo glifoi;
  int dis;
  Boolean seAvanza;
  seAvanza = FALSE;
  nd = 0;
  for ( nodol = tipo->palabras->primero;
        nodol != 0L;
	nodol = nodol->siguiente) {
    for (nodolglifo = ((tglifo)nodol->aitem)->listaGlifos->primero;
         nodolglifo != 0L;
	 nodolglifo = nodolglifo->siguiente){
      glifoi = nodolglifo->aglifo;
      if ( (glifoi->tipo == glifCar) &&
           (glifoch->tipo == glifCar) )
	if (strcmp(glifoi->letras, glifoch->letras) == 0) {
          dis = comparaVent ( glifoch->venDeGlifo, glifoi->venDeGlifo );
	  ponDiEnDistsdsLet (tipo->distsLet, glifoch->letras, dis);
	  nd ++;
	  seAvanza = TRUE;
	  if (nd >= NDMAXPASA) break;
	  }
      }
    if (nd >= NDMAXPASA) break;
    }
  return seAvanza;
}

int ajusteDePalabraaTipo (tglifo glifoPal, ttipo tipo)
{
  tglifo glifoch;
  tnodolglifo nodol;
  tdistds distrDis;
  int ndis, moda;
  int post, ndist, modat;
  int atr, satr;
  satr = 0;
  for(nodol = glifoPal->listaGlifos->primero;
      nodol != 0L;
      nodol = nodol->siguiente) {
    glifoch = nodol->aglifo;
    if ( (glifoch->tipo == glifCar) &&
	 (strlen(glifoch->letras) != 0) ) {
      distanciasDeLetraaTipo (&distrDis, glifoch, tipo);
      /** /
      escribeDistds (distrDis);
      / **/
      ndisyModaEnDistds (&ndis, &moda, distrDis);
      if (ndis > 0) {
	/** /
        printf ("ndis: %d,  moda: %3d\n", ndis, moda);
	/ **/
        posicionEnDistsdsLet (&post, &ndist, &modat,
		              tipo->distsLet, glifoch->letras, moda);
	/** /
        if (ndist != 0)
          printf ("post: %3d, ndist: %d,  modat: %3d\n", post, ndist, modat);
	/ **/
	modat = max(modat,2);  /* para eviatar dividir por 0, (2 arbitrario) */
        if (ndist > 0) {
          atr = max(-110, 30 - (10 * moda)/modat);
          satr += atr;
	  /** /
          printf ("atr: %3d, satr: %4d\n", atr, satr);
	  / **/
          }
        }
      }
    }
  return satr;
}

Boolean pasaDistanciasDesde1PalabraAditrbs (ttipo tipo, tglifo glifoPal)
{
  tnodolglifo nodol;
  tglifo glifoch;
  Boolean seAvanza;
  seAvanza = FALSE;
  for(nodol = glifoPal->listaGlifos->primero;
      nodol != 0L;
      nodol = nodol->siguiente) {
    glifoch = nodol->aglifo;
    if ( (glifoch->tipo == glifCar) &&
	 (strlen(glifoch->letras) != 0) ) {
      seAvanza = pasaDistanciasDesde1LetraaAditrbs (tipo, glifoch) || seAvanza ;
      }
    }
  return seAvanza;
}

void actualizaMaxpar (tpgen glifo, tpgen maxpar)
{
  int np;
  np = parejasDeLetrasEnPalabra (glifo);
  if (np > ((tmaxpar)maxpar)->np) {
    ((tmaxpar)maxpar)->np    = np;
    ((tmaxpar)maxpar)->glifo = glifo;
    }
}

Boolean eligeSemilla (tglifo *glifoPalSemilla, lista palabras)
{
  struct temaxpar maxpar;
  Boolean encontrada;
  maxpar.np = 0;
  recorreListaAplicandoMasdat (palabras, (tpgen) &maxpar, actualizaMaxpar);
  encontrada = (maxpar.np != 0);
  *glifoPalSemilla = maxpar.glifo; 
  return encontrada;
}

void incluyePalabraEnTipo (ttipo tipo, tglifo glifoPal, lista palabrasSintipoN,
		Boolean *seAvanza)
{
  *seAvanza = pasaDistanciasDesde1PalabraAditrbs (tipo, glifoPal) || (*seAvanza) ;
  *seAvanza = pasaDistanciasEn1PalabraAditrbs (tipo->distsLet, glifoPal) || (*seAvanza) ;
  escribeDLet (tipo->distsLet);
  cambiaItemdelista (tipo->palabras, palabrasSintipoN, glifoPal);
}
 
Boolean separa1Tipo (ttipo *ntipo, lista palabrasSintipo)
{
  ttipo tipo;
  lista palabrasSintipoN;
  tnodol nodol;
  int ajusPg;
  tglifo glifoPal;
  tglifo semilla;
  Boolean encontradaSem;
  Boolean seAvanza;
  encontradaSem = eligeSemilla (&semilla, palabrasSintipo);
  if (encontradaSem) {
    escribePalabradeGlifoyPares (semilla);
    creaTipo (&tipo);
    pasaDistanciasEn1PalabraAditrbs (tipo->distsLet, semilla);
    cambiaItemdelista (tipo->palabras, palabrasSintipo, semilla);
    do {
      seAvanza = FALSE;
      palabrasSintipoN = copiaLista (palabrasSintipo);
      for (nodol = palabrasSintipo->primero;
           nodol != 0L;
           nodol = nodol->siguiente) {
        glifoPal = (tglifo) (nodol->aitem);
        escribePalabradeGlifoyPares ( glifoPal );
        ajusPg = ajusteDePalabraaTipo (glifoPal, tipo);
        /** /
        printf ("ajusPg: %3d\n", ajusPg);
        / **/
        if (ajusPg > 0) {
          incluyePalabraEnTipo (tipo, glifoPal, palabrasSintipoN, &seAvanza);
          }
        }
      intermcambiaNodosDelistas (palabrasSintipo, palabrasSintipoN);
      liberaNodosYlista (palabrasSintipoN);
      printf ("----------------\n");
      }
    while (seAvanza);
    *ntipo = tipo;
    printf ("================\n");
    }
  return encontradaSem;
}

void separaTipos (tglifo glifo)
{
  lista palabras, palabrasSintipo;
  ttipo tipo1, tipo2, tipo3, tipo4, tipo5, tipo6;
  listadePalabrasEnGlifo (&palabras, glifo);
  palabrasSintipo = copiaLista (palabras);
  separa1Tipo (&tipo1, palabrasSintipo);
  separa1Tipo (&tipo2, palabrasSintipo);
  separa1Tipo (&tipo3, palabrasSintipo);
  separa1Tipo (&tipo4, palabrasSintipo);
  separa1Tipo (&tipo5, palabrasSintipo);
  separa1Tipo (&tipo6, palabrasSintipo);
}
